import { Observable, Subscription } from 'rxjs';
import { ContributableViewContainer, PanelViewWithComponent } from '../../interfaces';
/** A registry entry for a registered provider. */
export interface Entry<O, P> {
    registrationOptions: O;
    provider: P;
}
export interface PanelViewProviderRegistrationOptions {
    id: string;
    container: typeof ContributableViewContainer;
}
export type ProvidePanelViewSignature = Observable<PanelViewWithComponent | null>;
/** @sri custom change */
export interface IPanelViewProviderRegistry {
    readonly providers: Observable<ProvidePanelViewSignature[]>;
    registerProvider(registrationOptions: PanelViewProviderRegistrationOptions, provider: ProvidePanelViewSignature): Subscription;
    registerProviders(entries: Entry<PanelViewProviderRegistrationOptions, ProvidePanelViewSignature>[]): Subscription;
    deregisterProvider(deregistrationOptions: PanelViewProviderRegistrationOptions): Subscription;
    getPanelView(id: string): Observable<(PanelViewWithComponent & PanelViewProviderRegistrationOptions) | null>;
    getPanelViews(container: typeof ContributableViewContainer): Observable<(PanelViewWithComponent & PanelViewProviderRegistrationOptions)[]>;
}
