import { URI, UriComponents } from '@vscode-alt/monaco-editor/esm/vs/base/common/uri.js';
import { GraphQLResolveInfo, GraphQLScalarType, GraphQLScalarTypeConfig } from 'graphql';
import { MyContext } from '@adminide-stack/core';
import { DocumentNode } from 'graphql';
import * as Apollo from '@apollo/client';
export type Maybe<T> = T | null;
export type InputMaybe<T> = Maybe<T>;
export type Exact<T extends {
    [key: string]: unknown;
}> = {
    [K in keyof T]: T[K];
};
export type MakeOptional<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]?: Maybe<T[SubKey]>;
};
export type MakeMaybe<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]: Maybe<T[SubKey]>;
};
export type MakeEmpty<T extends {
    [key: string]: unknown;
}, K extends keyof T> = {
    [_ in K]?: never;
};
export type Incremental<T> = T | {
    [P in keyof T]?: P extends ' $fragmentName' | '__typename' ? T[P] : never;
};
export type RequireFields<T, K extends keyof T> = Omit<T, K> & {
    [P in K]-?: NonNullable<T[P]>;
};
/** All built-in and custom scalars, mapped to their actual values */
export type Scalars = {
    ID: {
        input: string;
        output: string;
    };
    String: {
        input: string;
        output: string;
    };
    Boolean: {
        input: boolean;
        output: boolean;
    };
    Int: {
        input: number;
        output: number;
    };
    Float: {
        input: number;
        output: number;
    };
    AnyObject: {
        input: any;
        output: any;
    };
    Date: {
        input: any;
        output: any;
    };
    DateTime: {
        input: any;
        output: any;
    };
    JSON: {
        input: any;
        output: any;
    };
    JSONObject: {
        input: any;
        output: any;
    };
    Observable: {
        input: any;
        output: any;
    };
    Time: {
        input: any;
        output: any;
    };
    Timestamp: {
        input: any;
        output: any;
    };
    URI: {
        input: URI;
        output: URI;
    };
    URIInput: {
        input: URI | UriComponents;
        output: URI | UriComponents;
    };
};
export type IAdminIdeSettings = {
    __typename?: 'AdminIdeSettings';
    dummy?: Maybe<Scalars['Int']['output']>;
};
export type IAnchor = {
    __typename?: 'Anchor';
    height?: Maybe<Scalars['Int']['output']>;
    width?: Maybe<Scalars['Int']['output']>;
    x?: Maybe<Scalars['Int']['output']>;
    y?: Maybe<Scalars['Int']['output']>;
};
export type IAnchorInput = {
    height?: InputMaybe<Scalars['Int']['input']>;
    width?: InputMaybe<Scalars['Int']['input']>;
    x?: InputMaybe<Scalars['Int']['input']>;
    y?: InputMaybe<Scalars['Int']['input']>;
};
export type IArgsType = {
    __typename?: 'ArgsType';
    constraint?: Maybe<Scalars['String']['output']>;
    description?: Maybe<Scalars['String']['output']>;
    name?: Maybe<Scalars['String']['output']>;
};
export type IAssets = {
    __typename?: 'Assets';
    Content?: Maybe<Scalars['String']['output']>;
    Type?: Maybe<Scalars['String']['output']>;
};
export type IAuthor = {
    __typename?: 'Author';
    name?: Maybe<Scalars['String']['output']>;
};
export type IBaseExtension = {
    __typename?: 'BaseExtension';
    /** @deprecated */
    galleryIdentifier?: Maybe<IExtensionIdentifier>;
    identifier?: Maybe<IExtensionIdentifier>;
    location?: Maybe<Scalars['URI']['output']>;
    manifest?: Maybe<IExtensionManifest>;
    type?: Maybe<IExtensionType>;
};
export type IBundles = {
    __typename?: 'Bundles';
    browser?: Maybe<Scalars['String']['output']>;
    server?: Maybe<Scalars['String']['output']>;
};
export declare enum IClientContainerService {
    ExtensionController = "ExtensionController"
}
export type ICommandHandlerDescriptionType = {
    __typename?: 'CommandHandlerDescriptionType';
    args?: Maybe<Array<Maybe<IArgsType>>>;
    description?: Maybe<Scalars['String']['output']>;
    returns?: Maybe<Scalars['String']['output']>;
};
export type ICommandType = {
    __typename?: 'CommandType';
    description?: Maybe<ICommandHandlerDescriptionType>;
    handler?: Maybe<Scalars['AnyObject']['output']>;
    id?: Maybe<Scalars['String']['output']>;
};
export type ICommandsType = {
    __typename?: 'CommandsType';
    commands?: Maybe<Array<Maybe<ICommandType>>>;
};
export type IContextMenu = {
    __typename?: 'ContextMenu';
    anchor?: Maybe<IAnchor>;
    id?: Maybe<Scalars['String']['output']>;
    isShow?: Maybe<Scalars['Boolean']['output']>;
    menuItems?: Maybe<Array<Maybe<IMenuItem>>>;
};
export type IContextMenuInput = {
    anchor?: InputMaybe<IAnchorInput>;
    isShow?: InputMaybe<Scalars['Boolean']['input']>;
    menuItems?: InputMaybe<Array<InputMaybe<IMenuItemInput>>>;
};
/** @deprecated use IExtensionContributions */
export type IContributes = {
    __typename?: 'Contributes';
    actions?: Maybe<Array<Maybe<IContributionActions>>>;
    menus?: Maybe<IMenus>;
};
export type IContributionAction = {
    __typename?: 'ContributionAction';
    checked?: Maybe<Scalars['Boolean']['output']>;
    class?: Maybe<Scalars['String']['output']>;
    enabled?: Maybe<Scalars['Boolean']['output']>;
    id?: Maybe<Scalars['String']['output']>;
    label?: Maybe<Scalars['String']['output']>;
    radio?: Maybe<Scalars['Boolean']['output']>;
    run?: Maybe<IContributionActionRun>;
    tooltip?: Maybe<Scalars['String']['output']>;
};
export type IContributionActionInput = {
    checked?: InputMaybe<Scalars['Boolean']['input']>;
    class?: InputMaybe<Scalars['String']['input']>;
    enabled?: InputMaybe<Scalars['Boolean']['input']>;
    id?: InputMaybe<Scalars['String']['input']>;
    label?: InputMaybe<Scalars['String']['input']>;
    radio?: InputMaybe<Scalars['Boolean']['input']>;
    run?: InputMaybe<IContributionActionRunInput>;
    tooltip?: InputMaybe<Scalars['String']['input']>;
};
export type IContributionActionItem = {
    __typename?: 'ContributionActionItem';
    description?: Maybe<Scalars['String']['output']>;
    label?: Maybe<Scalars['String']['output']>;
};
export type IContributionActionRun = {
    __typename?: 'ContributionActionRun';
    document?: Maybe<Scalars['AnyObject']['output']>;
    type?: Maybe<IGraphqlCallType>;
    variables?: Maybe<Scalars['AnyObject']['output']>;
};
export type IContributionActionRunInput = {
    document?: InputMaybe<Scalars['AnyObject']['input']>;
    type?: InputMaybe<IGraphqlCallType>;
    variables?: InputMaybe<Scalars['AnyObject']['input']>;
};
export type IContributionActions = {
    __typename?: 'ContributionActions';
    actionItem?: Maybe<IContributionActionItem>;
    category?: Maybe<Scalars['String']['output']>;
    command?: Maybe<Scalars['String']['output']>;
    id?: Maybe<Scalars['String']['output']>;
    title?: Maybe<Scalars['String']['output']>;
};
export type IContributionView = {
    __typename?: 'ContributionView';
    id?: Maybe<Scalars['ID']['output']>;
    name?: Maybe<Scalars['String']['output']>;
};
export type IDebugger = {
    __typename?: 'Debugger';
    label?: Maybe<Scalars['String']['output']>;
    runtime?: Maybe<Scalars['String']['output']>;
    type?: Maybe<Scalars['String']['output']>;
};
/**  A CDECode product documentation page. */
export type IDocSitePage = {
    __typename?: 'DocSitePage';
    /**  The content, as Markdown-rendered HTML. */
    contentHTML: Scalars['String']['output'];
    /**  The filename of the file containing this page's content. */
    filePath: Scalars['String']['output'];
    /**  The page index, as rendered HTML. */
    indexHTML: Scalars['String']['output'];
    /**  The title of this page. */
    title: Scalars['String']['output'];
};
export type IDocumentFilter = {
    __typename?: 'DocumentFilter';
    language: Scalars['String']['output'];
    pattern?: Maybe<Scalars['String']['output']>;
    schema?: Maybe<Scalars['String']['output']>;
};
/** Represents a null return value. */
export type IEmptyResponse = {
    __typename?: 'EmptyResponse';
    alwaysNil?: Maybe<Scalars['String']['output']>;
};
export type IEngines = {
    __typename?: 'Engines';
    node?: Maybe<Scalars['String']['output']>;
    vscode?: Maybe<Scalars['String']['output']>;
};
export type IEnvironment = {
    __typename?: 'Environment';
    extHostLogsPath?: Maybe<Scalars['URI']['output']>;
    extensionDevelopmentLocationURI?: Maybe<Array<Maybe<Scalars['URI']['output']>>>;
    extensionEnabledProposedApi?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    extensionTestsLocationURI?: Maybe<Scalars['URI']['output']>;
    isExtensionDevelopment?: Maybe<Scalars['Boolean']['output']>;
    logExtensionHostCommunication?: Maybe<Scalars['Boolean']['output']>;
    logsPath?: Maybe<Scalars['String']['output']>;
    remoteAuthority?: Maybe<Scalars['String']['output']>;
    sessionId?: Maybe<Scalars['String']['output']>;
    sync?: Maybe<IEnvironmentSync>;
    userDataPath?: Maybe<Scalars['String']['output']>;
    /**  Settings Sync  */
    userDataSyncHome?: Maybe<Scalars['URI']['output']>;
    userDataSyncLogResource?: Maybe<Scalars['URI']['output']>;
    webviewCspSource?: Maybe<Scalars['String']['output']>;
    webviewExternalEndpoint?: Maybe<Scalars['String']['output']>;
    webviewResourceRoot?: Maybe<Scalars['String']['output']>;
};
export type IEnvironmentPayload = {
    extensionDevelopmentLocationURI?: InputMaybe<Array<InputMaybe<Scalars['URI']['input']>>>;
    extensionEnabledProposedApi?: InputMaybe<Array<InputMaybe<Scalars['String']['input']>>>;
    extensionTestsLocationURI?: InputMaybe<Scalars['URI']['input']>;
    isExtensionDevelopment?: InputMaybe<Scalars['Boolean']['input']>;
    sessionId?: InputMaybe<Scalars['String']['input']>;
    webviewCspSource?: InputMaybe<Scalars['String']['input']>;
    webviewResourceRoot?: InputMaybe<Scalars['String']['input']>;
};
export declare enum IEnvironmentSync {
    Off = "off",
    On = "on",
    Unset = "unset"
}
export type IExtensionColor = {
    __typename?: 'ExtensionColor';
    defaults?: Maybe<IExtensionColorTypes>;
    description?: Maybe<Scalars['String']['output']>;
    id?: Maybe<Scalars['ID']['output']>;
};
export type IExtensionColorTypes = {
    __typename?: 'ExtensionColorTypes';
    dark?: Maybe<Scalars['String']['output']>;
    highContrast?: Maybe<Scalars['String']['output']>;
    light?: Maybe<Scalars['String']['output']>;
};
export type IExtensionConfiguration = {
    __typename?: 'ExtensionConfiguration';
    properties?: Maybe<Scalars['JSON']['output']>;
};
export type IExtensionConfigurationProperty = {
    __typename?: 'ExtensionConfigurationProperty';
    defaults?: Maybe<Scalars['JSON']['output']>;
    description?: Maybe<Scalars['String']['output']>;
    type?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
};
export type IExtensionContributions = {
    __typename?: 'ExtensionContributions';
    /** @deprecated use commands */
    actions?: Maybe<Array<Maybe<IContributionActions>>>;
    /**
     * @title contributes.colors
     * @description Contributes new themable colors. These colors can be used by the extension in editor decorators and in the status bar. Once defined, users can customize the color in the workspace.colorCustomization setting and user themes can set the color value.
     *
     * @example
     * ```json
     *    "contributes": {
     *      "colors": [{
     *          "id": "superstatus.error",
     *          "description": "Color for error message in the status bar.",
     *          "defaults": {
     *              "dark": "errorForeground",
     *              "light": "errorForeground",
     *              "highContrast": "#010203"
     *          }
     *      }]
     *    }
     * ```
     * Color default values can be defined for light, dark and high contrast theme and can either be a reference to an existing color or a Color Hex Value.
     */
    colors?: Maybe<Array<Maybe<IExtensionColor>>>;
    /**
     * @title contributes.commands
     * @description Contribute the UI for a command consisting of a title and (optionally) an icon, category,
     * and enabled state. Enablement is expressed with `when` clauses. By default, commands show in the
     * Command Pallette but they can also show in other menus.
     *
     * Presentation of contributed commands depends on the containing menu. The Command Pallette, for instance, prefixes
     * commands with their `category`, allowing for easy grouping. However, the Command Pallette doesn't show icons nor disabled
     * commands. The editor context menu, on the other hand, show disabled items but doesn't show the category label.
     *
     * Note: When a command is invoked (from a key binding, from the Command Palette, any other menu, or programmatically), VS Code will emit an activationEvent onCommand:${command}.
     *
     * @example
     * ```
     *    "contributes": {
     *        "commands": [{
     *            "command": "extension.sayHello",
     *            "title": "Hello World",
     *            "category": "Hello"
     *        }]
     *    }
     * ```
     */
    commands?: Maybe<Array<Maybe<IContributionActions>>>;
    /**
     * @title contributes.configuration
     * @description Contribute configuration keys that will be exposed to the user. The user will be able to set these configuration options either from User Settings or from the Workspace Settings.
     * When contributing configuration keys, a JSON schema describing these keys is actually contributed. This ensures the user gets great tooling support when authoring VS Code settings files.
     * You can read these values from your extension using vscode.workspace.getConfiguration('myExtension').
     *
     * Note: If you use markdownDescription instead of description, your setting description will be rendered as Markdown in the settings UI.
     *
     * @example
     * ```
     * "contributes": {
     *     "configuration": {
     *         "type": "object",
     *         "title": "TypeScript configuration",
     *         "properties": {
     *             "typescript.useCodeSnippetsOnMethodSuggest": {
     *                 "type": "boolean",
     *                 "default": false,
     *                 "description": "Complete functions with their parameter signature."
     *             },
     *             "typescript.tsdk": {
     *                 "type": ["string", "null"],
     *                 "default": null,
     *                 "description": "Specifies the folder path containing the tsserver and lib*.d.ts files to use."
     *             }
     *         }
     *     }
     * }
     * ```
     */
    configuration?: Maybe<Array<Maybe<IExtensionConfiguration>>>;
    debuggers?: Maybe<Array<Maybe<IDebugger>>>;
    /**
     *      @title contributes.grammars
     *      @description Contribute a TextMate grammar to a language. You must provide the language this grammar applies to, the TextMate scopeName for the grammar and the file path.
     *
     *      Note: The file containing the grammar can be in JSON (filenames ending in .json) or in XML plist format (all other files).
     *
     *      @example
     *         ```json
     *         "contributes": {
     *             "grammars": [{
     *                 "language": "markdown",
     *                 "scopeName": "text.html.markdown",
     *                 "path": "./syntaxes/markdown.tmLanguage.json",
     *                 "embeddedLanguages": {
     *                     "meta.embedded.block.frontmatter": "yaml",
     *                     ...
     *                 }
     *             }]
     *         }
     * ```
     */
    grammars?: Maybe<Array<Maybe<IGrammar>>>;
    iconThemes?: Maybe<Array<Maybe<IThemeLabel>>>;
    /**
     * @title contributes.jsonValidation
     * @description Contribute a validation schema for a specific type of json file. The url value can be either a local path to a schema file included in the extension or a remote server URL such as a json schema store.
     *
     * @example
     *    "contributes": {
     *        "jsonValidation": [{
     *            "fileMatch": ".jshintrc",
     *            "url": "http://json.schemastore.org/jshintrc"
     *        }]
     *    }
     */
    jsonValidation?: Maybe<Array<Maybe<IExtensionJsonValidation>>>;
    /**
     * @title contributes.keybindings
     * @description Contribute a key binding rule defining what command should be invoked when the user presses a key combination. See the Key Bindings topic where key bindings are explained in detail.
     *
     * Contributing a key binding will cause the Default Keyboard Shortcuts to display your rule, and every UI representation of the command will now show the key binding you have added. And, of course, when the user presses the key combination the command will be invoked.
     *
     * Note: Because VS Code runs on Windows, macOS and Linux, where modifiers differ, you can use "key" to set the default key combination and overwrite it with a specific platform.
     *
     * Note: When a command is invoked (from a key binding or from the Command Palette), VS Code will emit an activationEvent onCommand:${command}.
     *
     * @example
     * Defining that Ctrl+F1 under Windows and Linux and Cmd+F1 under macOS trigger the "extension.sayHello" command:
     *
     * ```json
     * "contributes": {
     *     "keybindings": [{
     *         "command": "extension.sayHello",
     *         "key": "ctrl+f1",
     *         "mac": "cmd+f1",
     *         "when": "editorTextFocus"
     *     }]
     * }
     * ```
     */
    keybindings?: Maybe<Array<Maybe<IKeyBinding>>>;
    /**
     * @title contributes.languages
     * @description Contribute definition of a language. This will introduce a new language or enrich the knowledge VS Code has about a language.
     *
     * The main effects of contributes.languages are:
     *
     * Define a languageId that can be reused in other parts of VS Code API, such as vscode.TextDocument.getLanguageId() and the onLanguage Activation Events.
     * You can contribute a human-readable using the aliases field. The first item in the list will be used as the human-readable label.
     * Associate file name extensions, file name patterns, files that begin with a specific line (such as hashbang), mimetypes to that languageId.
     * Contribute a set of Declarative Language Features for the contributed language. Learn more about the configurable editing features in the Language Configuration Guide.
     *
     * @example
     * ```
     *    "contributes": {
     *        "languages": [{
     *            "id": "python",
     *            "extensions": [ ".py" ],
     *            "aliases": [ "Python", "py" ],
     *            "filenames": [ ... ],
     *            "firstLine": "^#!/.*\\bpython[0-9.-]*\\b",
     *            "configuration": "./language-configuration.json"
     *        }]
     *    }
     * ```
     */
    languages?: Maybe<Array<Maybe<IExtensionLanguage>>>;
    localizations?: Maybe<Array<Maybe<ILocalization>>>;
    /**
     * @title contributes.menus
     * @description Contribute a menu item for a command to the editor or Explorer. The menu item definition contains the command that should be invoked when selected and the condition under which the item should show. The latter is defined with the when clause, which uses the key bindings when clause contexts.
     *
     * In addition to the mandatory command property, an alternative command can be defined using the alt-property. It will be shown and invoked when pressing Alt while opening a menu.
     *
     * Last, a group property defines sorting and grouping of menu items. The navigation group is special as it will always be sorted to the top/beginning of a menu.
     *
     * Note that when clauses apply to menus and enablement clauses to commands. The enablement applies to all menus and even keybindings while the when only applies to a single menu.
     *
     * Currently extension writers can contribute to:
     *
     * The global Command Palette - commandPalette
     * The Explorer context menu - explorer/context
     * The editor context menu - editor/context
     * The editor title menu bar - editor/title
     * The editor title context menu - editor/title/context
     * The debug callstack view context menu - debug/callstack/context
     * The debug toolbar - debug/toolbar
     * The SCM title menu - scm/title
     * SCM resource groups menus - scm/resourceGroup/context
     * SCM resources menus - scm/resource/context
     * SCM change title menus - scm/change/title
     * The View title menu - view/title
     * The View item menu - view/item/context
     * The macOS Touch Bar - touchBar
     * The comment thread title - comments/commentThread/title
     * The comment thread actions - comments/commentThread/context
     * The comment title - comments/comment/title
     * The comment actions - comments/comment/context
     * Note: When a command is invoked from a (context) menu, VS Code tries to infer the currently selected resource and passes that as a parameter when invoking the command. For instance, a menu item inside the Explorer is passed the URI of the selected resource and a menu item inside an editor is passed the URI of the document.
     *
     * In addition to a title, commands can also define icons which VS Code will show in the editor title menu bar.
     *
     * @example
     * "contributes": {
     *     "menus": {
     *         "editor/title": [{
     *             "when": "resourceLangId == markdown",
     *             "command": "markdown.showPreview",
     *             "alt": "markdown.showPreviewToSide",
     *             "group": "navigation"
     *         }]
     *     }
     * }
     */
    menus?: Maybe<IMenus>;
    /**
     * @title contributes.snippets
     * @description Contribute snippets for a specific language. The language attribute is the language identifier and the path is the relative path to the snippet file, which defines snippets in the VS Code snippet format.
     *
     * @example
     *
     * ```json
     * "contributes": {
     *     "snippets": [{
     *         "language": "go",
     *         "path": "./snippets/go.json"
     *     }]
     * }
     * ```
     */
    snippets?: Maybe<Array<Maybe<ISnippet>>>;
    /**
     * @title contributes.themes
     * @description Contribute a TextMate theme to VS Code. You must specify a label, whether the theme is a dark theme or a light theme (such that the rest of VS Code changes to match your theme) and the path to the file (XML plist format).
     *
     * @example
     *    ```json
     *    "contributes": {
     *        "themes": [{
     *            "label": "Monokai",
     *            "uiTheme": "vs-dark",
     *            "path": "./themes/Monokai.tmTheme"
     *        }]
     *    }
     *    ```
     */
    themes?: Maybe<Array<Maybe<IThemeLabel>>>;
    /**
     * @title contributes.viewsContainers
     * @description Contribute a view container into which Custom views can be contributed. You must specify an identifier, title, and an icon for the view container. At present, you can contribute them to the Activity Bar (activitybar) only. Below example shows how the Package Explorer view container is contributed to the Activity Bar and how views are contributed to it.
     *
     * @example
     * ```json
     *    "contributes": {
     *            "viewsContainers": {
     *                "activitybar": [
     *                    {
     *                        "id": "package-explorer",
     *                        "title": "Package Explorer",
     *                        "icon": "resources/package-explorer.svg"
     *                    }
     *                ]
     *            },
     *            "views": {
     *                "package-explorer": [
     *                    {
     *                        "id": "package-dependencies",
     *                        "name": "Dependencies"
     *                    },
     *                    {
     *                        "id": "package-outline",
     *                        "name": "Outline"
     *                    }
     *                ]
     *            }
     *    }
     * ```
     */
    views?: Maybe<Scalars['JSON']['output']>;
    /**
     *  @title contributes.viewsContainers
     *  @description Contribute a view container into which Custom views can be contributed. You must specify an identifier, title, and an icon for the view container. At present, you can contribute them to the Activity Bar (activitybar) only. Below example shows how the Package Explorer view container is contributed to the Activity Bar and how views are contributed to it.
     *
     *  @example
     *     ```json
     *     "contributes": {
     *             "viewsContainers": {
     *                 "activitybar": [
     *                     {
     *                         "id": "package-explorer",
     *                         "title": "Package Explorer",
     *                         "icon": "resources/package-explorer.svg"
     *                     }
     *                 ]
     *             },
     *             "views": {
     *                 "package-explorer": [
     *                     {
     *                         "id": "package-dependencies",
     *                         "name": "Dependencies"
     *                     },
     *                     {
     *                         "id": "package-outline",
     *                         "name": "Outline"
     *                     }
     *                 ]
     *             }
     *     }
     * ```
     */
    viewsContainers?: Maybe<Scalars['JSON']['output']>;
};
/**
 * **!Do not construct directly!**
 * **!Only static methods because it gets serialized!**
 *
 * This represents the "canonical" version for an extension identifier. Exntension ids
 * have to be case-insensitive (due to the marketplace), but we must ensure case
 * preservation because the extension API is already public at this time.
 *
 * For example, given an extension with the publisher `"Hello` and the name `"World"`,
 * its canonical extension identifier is `"Hello.World"`. This extension could be
 * referenced in some other extension's dependencies using the string `"hello.world"`.
 *
 * To make matter more complicated, an extension can optionally have an UUID. When two
 * extensions have the same UUID, they are considered equal even if their identifier is different.
 */
export type IExtensionIdentifier = {
    __typename?: 'ExtensionIdentifier';
    id?: Maybe<Scalars['String']['output']>;
    uuid?: Maybe<Scalars['String']['output']>;
};
export type IExtensionInstance = {
    __typename?: 'ExtensionInstance';
    env?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    extensionID?: Maybe<Scalars['ID']['output']>;
    monit?: Maybe<IProcessMonitoring>;
    name?: Maybe<Scalars['String']['output']>;
    path?: Maybe<Scalars['String']['output']>;
    pid?: Maybe<Scalars['String']['output']>;
    status?: Maybe<Scalars['String']['output']>;
};
export type IExtensionJsonValidation = {
    __typename?: 'ExtensionJSONValidation';
    fileMatch?: Maybe<Scalars['String']['output']>;
    url?: Maybe<Scalars['String']['output']>;
};
export declare enum IExtensionKind {
    Ui = "ui",
    Workspace = "workspace"
}
export type IExtensionLanguage = {
    __typename?: 'ExtensionLanguage';
    aliases?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    extensions?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    id?: Maybe<Scalars['ID']['output']>;
};
export type IExtensionManifest = {
    __typename?: 'ExtensionManifest';
    /**  An array of the activation events for this extension.  */
    activationEvents?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    /** Add support for api:none */
    api?: Maybe<Scalars['String']['output']>;
    assets?: Maybe<Array<Maybe<IAssets>>>;
    author?: Maybe<IAuthor>;
    /**  Array of approved badges to display in the sidebar of the Marketplace's extension page. Each badge is an object containing 3 properties: url for the badge's image URL, href for the link users will follow when clicking the badge and description.  */
    badges?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    /**
     * @description Any development Node.js bugs reporting location of your extension.
     * @example
     *    "bugs": {
     *        "url": "https://github.com/Microsoft/vscode-wordcount/issues",
     *        "email": "smcbreen@microsoft.com"
     *    },
     */
    bugs?: Maybe<IExtensionManifestBugs>;
    bundle?: Maybe<Scalars['String']['output']>;
    bundleURL?: Maybe<Scalars['String']['output']>;
    bundles?: Maybe<IBundles>;
    /**  the categories you want to use for the extensions allowed values: [Programming Languages, Snippets, Linters, Themes, Debuggers, Formatters, Keymaps, SCM Providers, Other, Extension Packs, Language Packs]  */
    categories?: Maybe<Scalars['String']['output']>;
    /**  An object describing the extension's contributions.  */
    contributes?: Maybe<IExtensionContributions>;
    /**  Any runtime Node.js dependencies your extensions needs. Exactly the same as npm's dependencies.  */
    dependencies?: Maybe<Scalars['JSON']['output']>;
    /**  A short description of what your extension is and does.  */
    description?: Maybe<Scalars['String']['output']>;
    /** Any development Node.js dependencies your extension needs. Exactly the same as npm's devDependencies.  */
    devDependencies?: Maybe<Scalars['JSON']['output']>;
    /**  The display name for the extension used in the Marketplace.  */
    displayName?: Maybe<Scalars['String']['output']>;
    /** To enable proposed Api's */
    enableProposedApi?: Maybe<Scalars['Boolean']['output']>;
    /**
     *  An object containing at least the vscode key matching
     * the versions of VS Code that the extension
     * is compatible with. Cannot be *.
     * For example: ^0.10.5 indicates compatibility with a minimum VS Code version of 0.10.5.
     */
    engines?: Maybe<IEngines>;
    extension?: Maybe<IExtensionPackageType>;
    /**
     * An array with the ids of extensions that this extension depends on. These other extensions will be installed when the primary extension is installed. The id of an extension is always
     * `${publisher}.${name}`. For example: vscode.csharp.
     */
    extensionDependencies?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    extensionID?: Maybe<Scalars['String']['output']>;
    /** An extension can be of 'ui' | 'workspace' */
    extensionKind?: Maybe<IExtensionKind>;
    /**
     * An array with the ids of extensions bundled with this extension. These other extensions will be installed when the primary extension is installed. The id of an extension is always
     * `${publisher}.${name}`. For example: vscode.csharp.
     */
    extensionPack?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    /**  Helps format the Marketplace header to match your icon. See details below.  */
    galleryBanner?: Maybe<IGalleryBanner>;
    homepage?: Maybe<Scalars['String']['output']>;
    /**  The path to the icon of at least 128x128 pixels (256x256 for Retina screens).  */
    icon?: Maybe<Scalars['String']['output']>;
    /**  An array of keywords to make it easier to find the extension. These are included with other extension Tags on the Marketplace. This list is currently limited to 5 keywords.  */
    keywords?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    /**
     *  Refer to npm's documentation. If you do have a LICENSE file in the root of
     * your extension, the value for license should be "SEE LICENSE IN <filename>".
     */
    license?: Maybe<Scalars['String']['output']>;
    /**  The entry point to your extension  */
    main?: Maybe<Scalars['String']['output']>;
    /**  Controls the Markdown rendering engine used in the Marketplace. Either github (default) or standard.  */
    makrdown?: Maybe<Scalars['String']['output']>;
    /**  The name of the extension - should be all lowercase with no spaces  */
    name?: Maybe<Scalars['String']['output']>;
    /**  Sets the extension to be flagged as a Preview in the Marketplace.  */
    preview?: Maybe<Scalars['Boolean']['output']>;
    /**  The publisher name  */
    publisher?: Maybe<Scalars['String']['output']>;
    /**  Controls the Q & A link in the Marketplace. Set to marketplace to enable the default Marketplace Q & A site. Set to a string to provide the URL of a custom Q & A site. Set to false to disable Q & A altogether.  */
    qna?: Maybe<Scalars['String']['output']>;
    /** The raw JSON contents of the manifest. */
    raw?: Maybe<Scalars['String']['output']>;
    /** Readme */
    readme?: Maybe<Scalars['String']['output']>;
    /**
     * Any development Node.js repository location of your extension.
     * @example
     *   "repository": {
     *        "type": "git",
     *        "url": "https://github.com/Microsoft/vscode-wordcount.git"
     *    }
     */
    repository?: Maybe<IExtensionManifestRepository>;
    /**  Exactly the same as npm's scripts but with extra VS Code specific fields such as vscode:prepublish or vscode:uninstall.  */
    scripts?: Maybe<IScripts>;
    tags?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    url?: Maybe<Scalars['String']['output']>;
    /**  SemVer compatible version.  */
    version?: Maybe<Scalars['String']['output']>;
};
export type IExtensionManifestBugs = {
    __typename?: 'ExtensionManifestBugs';
    email?: Maybe<Scalars['String']['output']>;
    url?: Maybe<Scalars['String']['output']>;
};
export type IExtensionManifestRepository = {
    __typename?: 'ExtensionManifestRepository';
    type?: Maybe<Scalars['String']['output']>;
    url?: Maybe<Scalars['String']['output']>;
};
export type IExtensionPackageType = {
    __typename?: 'ExtensionPackageType';
    type?: Maybe<Scalars['String']['output']>;
};
export type IExtensionRegistry = {
    __typename?: 'ExtensionRegistry';
    /**  To find an extension by its GraphQL ID, use Query.node  */
    extension?: Maybe<IRegistryExtension>;
    /**
     * Find an extension by its extension ID (which is the concatenation of the publisher naem, a slash ("/"), and the extension name).
     *
     * To find an extension by its GraphQL ID, use Query.node
     * extension(extensionID: String!): RegistryExtension
     * A list of extensions published in the extension registry.
     */
    extensions: IRegistryExtensionConnection;
    /**
     * The extension ID prefix for extensions that are published in the local extension registry. This is the
     * hostname ( and port, if non-default HTTP/HTTPS) of the CDEBase "appURL" site configuration property.
     *
     * It is null if extensions published on this CDEBase site do not have an extension ID prefix.
     *
     * Examples: "cdebase.example.com/", "cdebase.example.com:1234/"
     */
    localExtensionIDPrefix?: Maybe<Scalars['String']['output']>;
    /**  A list of publishers with at least 1 extension in the registry.  */
    publishers: IRegistryPublisherConnection;
    /**  List of extension releases  */
    releases?: Maybe<Array<Maybe<IExtensionRelease>>>;
    /**  A list of publishers that the viewer may publish extensions as.  */
    viewerPublishers: Array<IRegistryPublisher>;
};
export type IExtensionRegistryExtensionArgs = {
    extensionID: Scalars['String']['input'];
};
export type IExtensionRegistryExtensionsArgs = {
    first?: InputMaybe<Scalars['Int']['input']>;
    includeWIP?: InputMaybe<Scalars['Boolean']['input']>;
    local?: InputMaybe<Scalars['Boolean']['input']>;
    prioritizeExtensionIDs?: InputMaybe<Array<Scalars['String']['input']>>;
    publisher?: InputMaybe<Scalars['ID']['input']>;
    query?: InputMaybe<Scalars['String']['input']>;
    remote?: InputMaybe<Scalars['Boolean']['input']>;
};
export type IExtensionRegistryPublishersArgs = {
    first?: InputMaybe<Scalars['Int']['input']>;
};
export type IExtensionRegistryReleasesArgs = {
    extensionID: Scalars['String']['input'];
};
/**  The result of Mutation.extensionRegistry.createExtension. */
export type IExtensionRegistryCreateExtensionResult = {
    __typename?: 'ExtensionRegistryCreateExtensionResult';
    /**  The newly created extension. */
    extension: IRegistryExtension;
};
/**  The result of Mutation.extensionRegistry.publishExtension. */
export type IExtensionRegistryPublishExtensionResult = {
    __typename?: 'ExtensionRegistryPublishExtensionResult';
    /**  The extension that was just published. */
    extension: IRegistryExtension;
};
/**  The result of Mutation.extensionRegistry.updateExtension. */
export type IExtensionRegistryUpdateExtensionResult = {
    __typename?: 'ExtensionRegistryUpdateExtensionResult';
    /**  The newly updated extension. */
    extension: IRegistryExtension;
};
export type IExtensionRelease = {
    __typename?: 'ExtensionRelease';
    activationEvents?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    bundle?: Maybe<Scalars['String']['output']>;
    bundleURL?: Maybe<Scalars['String']['output']>;
    creatorUserId?: Maybe<Scalars['String']['output']>;
    extensionID?: Maybe<Scalars['String']['output']>;
    id?: Maybe<Scalars['ID']['output']>;
    manifest: Scalars['String']['output'];
    releaseVersion?: Maybe<Scalars['String']['output']>;
    sourceMap?: Maybe<Scalars['String']['output']>;
    version?: Maybe<Scalars['String']['output']>;
};
export declare enum IExtensionType {
    System = "System",
    User = "User"
}
export type IFieldError = {
    __typename?: 'FieldError';
    field: Scalars['String']['output'];
    message: Scalars['String']['output'];
};
export type IGalleryBanner = {
    __typename?: 'GalleryBanner';
    color?: Maybe<Scalars['String']['output']>;
    theme?: Maybe<Scalars['String']['output']>;
};
export type IGalleryExtension = {
    __typename?: 'GalleryExtension';
    assets?: Maybe<IGalleryExtensionAssets>;
    date?: Maybe<Scalars['String']['output']>;
    description?: Maybe<Scalars['String']['output']>;
    displayName?: Maybe<Scalars['String']['output']>;
    icon?: Maybe<Scalars['String']['output']>;
    id?: Maybe<Scalars['String']['output']>;
    identifier?: Maybe<IExtensionIdentifier>;
    installCount?: Maybe<Scalars['Int']['output']>;
    name?: Maybe<Scalars['String']['output']>;
    preview?: Maybe<Scalars['Boolean']['output']>;
    properties?: Maybe<IGalleryExtensionProperties>;
    publisher?: Maybe<Scalars['String']['output']>;
    publisherDisplayName?: Maybe<Scalars['String']['output']>;
    publisherId?: Maybe<Scalars['String']['output']>;
    rating?: Maybe<Scalars['Float']['output']>;
    ratingCount?: Maybe<Scalars['Float']['output']>;
    resources?: Maybe<IGalleryExtensionResources>;
    version?: Maybe<Scalars['String']['output']>;
};
export type IGalleryExtensionAsset = {
    __typename?: 'GalleryExtensionAsset';
    fallbackUri?: Maybe<Scalars['String']['output']>;
    uri?: Maybe<Scalars['String']['output']>;
};
export type IGalleryExtensionAssets = {
    __typename?: 'GalleryExtensionAssets';
    changelog?: Maybe<IGalleryExtensionAsset>;
    coreTranslations?: Maybe<Scalars['JSON']['output']>;
    download?: Maybe<IGalleryExtensionAsset>;
    icon?: Maybe<IGalleryExtensionAsset>;
    license?: Maybe<IGalleryExtensionAsset>;
    manifest?: Maybe<IGalleryExtensionAsset>;
    readme?: Maybe<IGalleryExtensionAsset>;
    repository?: Maybe<IGalleryExtensionAsset>;
};
export type IGalleryExtensionProperties = {
    __typename?: 'GalleryExtensionProperties';
    dependencies?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    engine?: Maybe<Scalars['String']['output']>;
    extensionPack?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    localizedLanguages?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
};
export type IGalleryExtensionResources = {
    __typename?: 'GalleryExtensionResources';
    changelog?: Maybe<Scalars['String']['output']>;
    download?: Maybe<Scalars['String']['output']>;
    icon?: Maybe<Scalars['String']['output']>;
    license?: Maybe<Scalars['String']['output']>;
    manifest?: Maybe<Scalars['String']['output']>;
    readme?: Maybe<Scalars['String']['output']>;
    repository?: Maybe<Scalars['String']['output']>;
};
export type IGalleryFilter = {
    filterType?: InputMaybe<Scalars['String']['input']>;
    value?: InputMaybe<Scalars['String']['input']>;
};
export type IGalleryPager = {
    __typename?: 'GalleryPager';
    firstPage?: Maybe<Array<Maybe<IGalleryExtension>>>;
    page?: Maybe<Scalars['Int']['output']>;
    pageSize?: Maybe<Scalars['Int']['output']>;
    total?: Maybe<Scalars['Int']['output']>;
};
export type IGalleryQueryInput = {
    ids?: InputMaybe<Array<InputMaybe<Scalars['String']['input']>>>;
    names?: InputMaybe<Array<InputMaybe<Scalars['String']['input']>>>;
    pageSize?: InputMaybe<Scalars['Int']['input']>;
    sortBy?: InputMaybe<Scalars['Int']['input']>;
    sortOrder?: InputMaybe<Scalars['Int']['input']>;
    source?: InputMaybe<Scalars['String']['input']>;
    text?: InputMaybe<Scalars['String']['input']>;
};
export type IGeoLocation = {
    __typename?: 'GeoLocation';
    coordinates?: Maybe<Array<Maybe<Scalars['Float']['output']>>>;
};
export type IGrammar = {
    __typename?: 'Grammar';
    language?: Maybe<Scalars['String']['output']>;
};
export declare enum IGraphqlCallType {
    Mutation = "mutation",
    Query = "query"
}
export type IHover = {
    contents?: Maybe<IMarkupContent>;
    range?: Maybe<IRange>;
};
export type IIActivationRequest = {
    env?: InputMaybe<Array<InputMaybe<Scalars['String']['input']>>>;
    extensionID: Scalars['ID']['input'];
};
export type IIBehaviorSubject = {
    __typename?: 'IBehaviorSubject';
    _isScalar?: Maybe<Scalars['Boolean']['output']>;
    closed?: Maybe<Scalars['Boolean']['output']>;
    hasError?: Maybe<Scalars['Boolean']['output']>;
    isStopped?: Maybe<Scalars['Boolean']['output']>;
    observers?: Maybe<Array<Maybe<Scalars['JSON']['output']>>>;
    thrownError?: Maybe<Scalars['String']['output']>;
    value?: Maybe<Array<Maybe<IIBehaviorSubjectValue>>>;
};
export type IIBehaviorSubjectValue = {
    __typename?: 'IBehaviorSubjectValue';
    provider?: Maybe<Scalars['String']['output']>;
    registrationOptions?: Maybe<IIDocumentSelector>;
};
export type IIDestinationAnonymousSubject = {
    __typename?: 'IDestinationAnonymousSubject';
    _isScalar?: Maybe<Scalars['Boolean']['output']>;
    closed?: Maybe<Scalars['Boolean']['output']>;
    destination?: Maybe<Scalars['String']['output']>;
    hasError?: Maybe<Scalars['Boolean']['output']>;
    isStopped?: Maybe<Scalars['Boolean']['output']>;
    observers?: Maybe<Array<Maybe<Scalars['JSON']['output']>>>;
    operator?: Maybe<IISwitchMapOperator>;
    source?: Maybe<IIBehaviorSubject>;
    thrownError?: Maybe<Scalars['String']['output']>;
};
export type IIDocumentSelector = {
    __typename?: 'IDocumentSelector';
    documentSelector?: Maybe<Scalars['JSON']['output']>;
};
export type IIModel = {
    __typename?: 'IModel';
    roots?: Maybe<IIWorkspaceRoot>;
    visibleViewComponents?: Maybe<Array<Maybe<IIViewComponentData>>>;
};
export type IIModelInput = {
    roots?: InputMaybe<IIWorkspaceRootInput>;
    visibleViewComponents?: InputMaybe<Array<InputMaybe<IIViewComponentDataInput>>>;
};
export type IIObservableResult = {
    __typename?: 'IObservableResult';
    _isScalar?: Maybe<Scalars['Boolean']['output']>;
    closed?: Maybe<Scalars['Boolean']['output']>;
    destination?: Maybe<IIDestinationAnonymousSubject>;
    hasError?: Maybe<Scalars['Boolean']['output']>;
    isStopped?: Maybe<Scalars['Boolean']['output']>;
    observers?: Maybe<Array<Maybe<Scalars['JSON']['output']>>>;
    operator?: Maybe<IISwitchMapOperator>;
    source?: Maybe<IISourceAnonymousSubject>;
    thrownError?: Maybe<Scalars['String']['output']>;
};
export type IIResourceUtilizationSettings = {
    adminApiNamespace?: Maybe<Scalars['String']['output']>;
    subTopic?: Maybe<Scalars['String']['output']>;
};
export type IISourceAnonymousSubject = {
    __typename?: 'ISourceAnonymousSubject';
    _isScalar?: Maybe<Scalars['Boolean']['output']>;
    closed?: Maybe<Scalars['Boolean']['output']>;
    destination?: Maybe<IIDestinationAnonymousSubject>;
    hasError?: Maybe<Scalars['Boolean']['output']>;
    isStopped?: Maybe<Scalars['Boolean']['output']>;
    observers?: Maybe<Array<Maybe<Scalars['JSON']['output']>>>;
    operator?: Maybe<IISwitchMapOperator>;
    source?: Maybe<IIBehaviorSubject>;
    thrownError?: Maybe<Scalars['String']['output']>;
};
export type IISwitchMapOperator = {
    __typename?: 'ISwitchMapOperator';
    project?: Maybe<Scalars['String']['output']>;
};
export type IITextDocumentIdentifier = {
    /** just to statisfy few issues */
    languageId?: Maybe<Scalars['String']['output']>;
    uri?: Maybe<Scalars['URI']['output']>;
};
export type IIViewComponentData = {
    __typename?: 'IViewComponentData';
    isActive?: Maybe<Scalars['Boolean']['output']>;
    item?: Maybe<ITextDocumentItem>;
    type?: Maybe<Scalars['String']['output']>;
};
export type IIViewComponentDataInput = {
    isActive?: InputMaybe<Scalars['Boolean']['input']>;
    item?: InputMaybe<ITextDocumentItemInput>;
    type?: InputMaybe<Scalars['String']['input']>;
};
export type IIWorkspaceRoot = {
    __typename?: 'IWorkspaceRoot';
    url?: Maybe<Scalars['String']['output']>;
};
export type IIWorkspaceRootInput = {
    url?: InputMaybe<Scalars['String']['input']>;
};
export type IInstalledExtension = {
    __typename?: 'InstalledExtension';
    extension?: Maybe<IGalleryExtension>;
    galleryIdentifier?: Maybe<IExtensionIdentifier>;
    identifier?: Maybe<IExtensionIdentifier>;
};
export type IKeyBinding = {
    __typename?: 'KeyBinding';
    command?: Maybe<Scalars['String']['output']>;
    key?: Maybe<Scalars['String']['output']>;
    linux?: Maybe<Scalars['String']['output']>;
    mac?: Maybe<Scalars['String']['output']>;
    when?: Maybe<Scalars['String']['output']>;
    win?: Maybe<Scalars['String']['output']>;
};
export type ILocalization = {
    __typename?: 'Localization';
    languageId?: Maybe<Scalars['String']['output']>;
    languageName?: Maybe<Scalars['String']['output']>;
    localizedLanguageName?: Maybe<Scalars['String']['output']>;
    minimalTranslations?: Maybe<Scalars['JSON']['output']>;
    translations?: Maybe<Array<Maybe<ILocalizationTranslation>>>;
};
export type ILocalizationTranslation = {
    __typename?: 'LocalizationTranslation';
    id?: Maybe<Scalars['ID']['output']>;
    path?: Maybe<Scalars['String']['output']>;
};
/**
 * Represents a location inside a resource, such as a line
 * inside a text file.
 */
export type ILocation = {
    range?: Maybe<IPosition>;
    rangeOrUri?: Maybe<IPosition>;
    uri?: Maybe<Scalars['String']['output']>;
    uriRangeOrPosition?: Maybe<Scalars['String']['output']>;
};
export declare enum IMailTemplateId {
    Dummy = "dummy"
}
export type IMarkupContent = {
    kind?: Maybe<IMarkupKind>;
    value?: Maybe<Scalars['String']['output']>;
};
export declare enum IMarkupKind {
    Markdown = "markdown",
    Plaintext = "plaintext"
}
export declare enum IMenuId {
    CommandPalette = "CommandPalette",
    CommentActions = "CommentActions",
    CommentThreadActions = "CommentThreadActions",
    CommentThreadTitle = "CommentThreadTitle",
    CommentTitle = "CommentTitle",
    MenubarAppearanceMenu = "MenubarAppearanceMenu",
    MenubarDebugMenu = "MenubarDebugMenu",
    MenubarEditMenu = "MenubarEditMenu",
    MenubarFileMenu = "MenubarFileMenu",
    MenubarGoMenu = "MenubarGoMenu",
    MenubarNewBreakpointMenu = "MenubarNewBreakpointMenu",
    MenubarPreferencesMenu = "MenubarPreferencesMenu",
    MenubarRecentMenu = "MenubarRecentMenu",
    MenubarSelectionMenu = "MenubarSelectionMenu",
    MenubarSwitchEditorMenu = "MenubarSwitchEditorMenu",
    MenubarSwitchGroupMenu = "MenubarSwitchGroupMenu",
    MenubarTeamMenu = "MenubarTeamMenu",
    MenubarViewMenu = "MenubarViewMenu",
    OpenEditorContext = "OpenEditorContext",
    ProblemsPanelContext = "ProblemsPanelContext",
    ScmChangeContext = "SCMChangeContext",
    ScmResourceContext = "SCMResourceContext",
    ScmResourceControl = "SCMResourceControl",
    ScmResourceGroupContext = "SCMResourceGroupContext",
    ScmTitle = "SCMTitle",
    SearchContext = "SearchContext",
    StatusBarWindowIndicatorMenu = "StatusBarWindowIndicatorMenu",
    TouchBarContext = "TouchBarContext",
    ViewItemContext = "ViewItemContext",
    ViewTitle = "ViewTitle"
}
export type IMenuItem = {
    __typename?: 'MenuItem';
    enabled?: Maybe<Scalars['Boolean']['output']>;
    id?: Maybe<Scalars['String']['output']>;
    label?: Maybe<Scalars['String']['output']>;
    run?: Maybe<IContributionActionRun>;
};
export type IMenuItemAction = {
    __typename?: 'MenuItemAction';
    action?: Maybe<Scalars['String']['output']>;
    when?: Maybe<Scalars['String']['output']>;
};
export type IMenuItemActionContext = {
    __typename?: 'MenuItemActionContext';
    context?: Maybe<Array<Maybe<IMenuItemAction>>>;
};
export type IMenuItemActionDebug = {
    __typename?: 'MenuItemActionDebug';
    callstack?: Maybe<IMenuItemActionContext>;
    toolbar?: Maybe<Array<Maybe<IMenuItemAction>>>;
};
export type IMenuItemActionEditor = {
    __typename?: 'MenuItemActionEditor';
    context?: Maybe<Array<Maybe<IMenuItemAction>>>;
    title?: Maybe<IMenuItemActionEditorTitle>;
};
export type IMenuItemActionEditorTitle = {
    __typename?: 'MenuItemActionEditorTitle';
    context?: Maybe<Array<Maybe<IMenuItemAction>>>;
    own?: Maybe<Array<Maybe<IMenuItemAction>>>;
};
export type IMenuItemActionScm = {
    __typename?: 'MenuItemActionScm';
    change?: Maybe<IMenuItemActionScmChange>;
    resource?: Maybe<IMenuItemActionContext>;
    /**  The Source Control resource group context menu  */
    resourceGroup?: Maybe<IMenuItemActionContext>;
    /**  The Source Control title menu  */
    title?: Maybe<Array<Maybe<IMenuItemAction>>>;
};
export type IMenuItemActionScmChange = {
    __typename?: 'MenuItemActionScmChange';
    title?: Maybe<Array<Maybe<IMenuItemAction>>>;
};
export type IMenuItemActionView = {
    __typename?: 'MenuItemActionView';
    /**  The contributed view item context menu  */
    item?: Maybe<IMenuItemActionContext>;
    /**  The contributed view title menu  */
    title?: Maybe<Array<Maybe<IMenuItemAction>>>;
};
export type IMenuItemInput = {
    enabled?: InputMaybe<Scalars['Boolean']['input']>;
    id?: InputMaybe<Scalars['String']['input']>;
    label?: InputMaybe<Scalars['String']['input']>;
    run?: InputMaybe<IContributionActionRunInput>;
};
export type IMenus = {
    __typename?: 'Menus';
    /**  The Command Palette  */
    commandPalette?: Maybe<Array<Maybe<IMenuItemAction>>>;
    /**  The debug  */
    debug?: Maybe<IMenuItemActionDebug>;
    /**  The editor  */
    editor?: Maybe<IMenuItemActionEditor>;
    /**  The file explorer  */
    explorer?: Maybe<IMenuItemActionContext>;
    /**  The Source Control  */
    scm?: Maybe<IMenuItemActionScm>;
    /**  The touch bar (macOS only)  */
    touchBar?: Maybe<Array<Maybe<IMenuItemAction>>>;
    /**  The contributed view  */
    view?: Maybe<IMenuItemActionView>;
};
export type IMessageLink = {
    __typename?: 'MessageLink';
    href?: Maybe<Scalars['String']['output']>;
    length?: Maybe<Scalars['Int']['output']>;
    name?: Maybe<Scalars['String']['output']>;
    offset?: Maybe<Scalars['Int']['output']>;
};
export type IMessageLinkInput = {
    href?: InputMaybe<Scalars['String']['input']>;
    length?: InputMaybe<Scalars['Int']['input']>;
    name?: InputMaybe<Scalars['String']['input']>;
    offset?: InputMaybe<Scalars['Int']['input']>;
};
export declare enum IMoleculerCronServiceName {
    Dummy = "dummy"
}
/** All Moleculer Topic names are extended from this. */
export declare enum IMoleculerServiceName {
    Dummy = "dummy"
}
export type IMutation = {
    __typename?: 'Mutation';
    activate?: Maybe<Scalars['Boolean']['output']>;
    addNotification?: Maybe<Scalars['Boolean']['output']>;
    closeNotification?: Maybe<Scalars['Boolean']['output']>;
    codeLenseProviderDefinition?: Maybe<Scalars['Observable']['output']>;
    completionProviderDefinition?: Maybe<Scalars['Observable']['output']>;
    copy?: Maybe<Scalars['Boolean']['output']>;
    /**  Create a new extension in the extension registry. */
    createExtension: IRegistryExtension;
    definitionDefinition?: Maybe<Scalars['Observable']['output']>;
    /**
     * Delete an extension from the extension registry.
     *
     * Only authorized extension publishers may perform this mutation.
     */
    deleteExtension: IEmptyResponse;
    documentFormattingProviderDefinition?: Maybe<Scalars['Observable']['output']>;
    documentHighLightProviderDefinition?: Maybe<Scalars['Observable']['output']>;
    documentSymbolDefinition?: Maybe<Scalars['Observable']['output']>;
    dummy?: Maybe<Scalars['Int']['output']>;
    handler?: Maybe<Scalars['Boolean']['output']>;
    hideContextMenu?: Maybe<Scalars['Boolean']['output']>;
    hoverProviderDefinition?: Maybe<Scalars['Observable']['output']>;
    install?: Maybe<IExtensionIdentifier>;
    notify?: Maybe<Scalars['Boolean']['output']>;
    notifyError?: Maybe<Scalars['Boolean']['output']>;
    notifyInfo?: Maybe<Scalars['Boolean']['output']>;
    notifyPrompt?: Maybe<Scalars['Boolean']['output']>;
    notifyWarn?: Maybe<Scalars['Boolean']['output']>;
    openLanguageDocument?: Maybe<Scalars['Observable']['output']>;
    /**
     * Publish an extension in the extension registry, creating it (if it doesn't yet exist) or updating it (if it
     * does).
     *
     * This is a helper that wraps multiple other GraphQL mutations to expose a single API for publishing an
     * extension.
     */
    publishExtension: IExtensionRegistryPublishExtensionResult;
    referenceProviderDefinition?: Maybe<Scalars['Observable']['output']>;
    removeExtension?: Maybe<Scalars['Boolean']['output']>;
    renameDefinition?: Maybe<Scalars['Observable']['output']>;
    runMenuAction?: Maybe<Scalars['Boolean']['output']>;
    showContextMenu?: Maybe<Scalars['Boolean']['output']>;
    startExtensionHost?: Maybe<Scalars['Boolean']['output']>;
    /**
     * Update an extension in the extension registry.
     *
     * Only authorized extension publishers may perform this mutation.
     */
    updateExtension: IRegistryExtension;
    /** @deprecated need to remove */
    updateModel?: Maybe<Scalars['Boolean']['output']>;
};
export type IMutationActivateArgs = {
    request: IIActivationRequest;
};
export type IMutationAddNotificationArgs = {
    notification?: InputMaybe<INotificationInput>;
};
export type IMutationCloseNotificationArgs = {
    index?: InputMaybe<Scalars['Int']['input']>;
};
export type IMutationCodeLenseProviderDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationCompletionProviderDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationCopyArgs = {
    value?: InputMaybe<Scalars['String']['input']>;
};
export type IMutationCreateExtensionArgs = {
    name: Scalars['String']['input'];
    publisher: Scalars['ID']['input'];
};
export type IMutationDefinitionDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationDeleteExtensionArgs = {
    extension: Scalars['ID']['input'];
};
export type IMutationDocumentFormattingProviderDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationDocumentHighLightProviderDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationDocumentSymbolDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationHandlerArgs = {
    arg?: InputMaybe<IContributionActionRunInput>;
};
export type IMutationHoverProviderDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationInstallArgs = {
    vsix: Scalars['String']['input'];
};
export type IMutationNotifyArgs = {
    notification?: InputMaybe<INotificationInput>;
};
export type IMutationNotifyErrorArgs = {
    message?: InputMaybe<Array<InputMaybe<INotificationMessageInput>>>;
};
export type IMutationNotifyInfoArgs = {
    message?: InputMaybe<Array<InputMaybe<INotificationMessageInput>>>;
};
export type IMutationNotifyPromptArgs = {
    choices?: InputMaybe<Array<InputMaybe<IPromptChoiceInput>>>;
    message?: InputMaybe<Scalars['String']['input']>;
    options?: InputMaybe<IPromptOptionsInput>;
    severity?: InputMaybe<INotificationSeverity>;
};
export type IMutationNotifyWarnArgs = {
    message?: InputMaybe<Array<InputMaybe<INotificationMessageInput>>>;
};
export type IMutationOpenLanguageDocumentArgs = {
    params?: InputMaybe<IOpenDocumentParamsInput>;
};
export type IMutationPublishExtensionArgs = {
    bundle?: InputMaybe<Scalars['String']['input']>;
    extensionID: Scalars['String']['input'];
    force?: InputMaybe<Scalars['Boolean']['input']>;
    manifest: Scalars['String']['input'];
    name?: InputMaybe<Scalars['String']['input']>;
    sourceMap?: InputMaybe<Scalars['String']['input']>;
    version?: InputMaybe<Scalars['String']['input']>;
};
export type IMutationReferenceProviderDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationRemoveExtensionArgs = {
    id: Scalars['String']['input'];
};
export type IMutationRenameDefinitionArgs = {
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
};
export type IMutationRunMenuActionArgs = {
    argument?: InputMaybe<IContributionActionRunInput>;
};
export type IMutationShowContextMenuArgs = {
    delegate?: InputMaybe<IContextMenuInput>;
};
export type IMutationStartExtensionHostArgs = {
    request?: InputMaybe<Scalars['String']['input']>;
};
export type IMutationUpdateExtensionArgs = {
    extension: Scalars['ID']['input'];
    name?: InputMaybe<Scalars['String']['input']>;
};
export type IMutationUpdateModelArgs = {
    model?: InputMaybe<IIModelInput>;
};
/** An object with an ID. */
export type INode = {
    /** The ID of the node. */
    id: Scalars['ID']['output'];
};
export type INotification = {
    __typename?: 'Notification';
    /**
     * ContributionActions to show as part of the notification. Primary actions show up as
     * buttons as part of the message and will clost the notification once clicked.
     *
     * Secondary actions are meant to provide additional configuration or context
     * for the notification and will show up less prominent. A notification does not
     * close automatically when invoking a secondary action.
     *
     * **Note:** If you intent is to show a message with actions to the user, consider
     * the `INotificationService.prompt()` method instead which are optimized for
     * this usecase and much easier to use!
     */
    actions?: Maybe<INotificationActions>;
    index?: Maybe<Scalars['Boolean']['output']>;
    /**
     * The message of the notification. This can either be a `string` or `Error`. Messages
     * can optionally include links in the format: `[text](link)`
     */
    message?: Maybe<Scalars['String']['output']>;
    /** The severity of the notification. Either `Info`, `Warning` or `Error`. */
    severity?: Maybe<INotificationSeverity>;
    /** The source of the notification appears as additional information. */
    source?: Maybe<Scalars['String']['output']>;
    /**
     * Sticky notifications are not automatically removed after a certain timeout. By
     * default, notifications with primary actions and severity error are always sticky.
     */
    sticky?: Maybe<Scalars['Boolean']['output']>;
};
export type INotificationActions = {
    __typename?: 'NotificationActions';
    /**
     * Primary actions show up as buttons as part of the message and will close
     * the notification once clicked.
     */
    primary?: Maybe<Array<Maybe<IContributionAction>>>;
    /**
     * Secondary actions are meant to provide additional configuration or context
     * for the notification and will show up less prominent. A notification does not
     * close automatically when invoking a secondary action.
     */
    secondary?: Maybe<Array<Maybe<IContributionAction>>>;
};
export type INotificationActionsInput = {
    primary?: InputMaybe<Array<InputMaybe<IContributionActionInput>>>;
    secondary?: InputMaybe<Array<InputMaybe<IContributionActionInput>>>;
};
export type INotificationChangeEvent = {
    __typename?: 'NotificationChangeEvent';
    /** The index this notification has in the list of notifications. */
    index?: Maybe<Scalars['Int']['output']>;
    /** The notification this change is about. */
    item?: Maybe<INotificationViewItem>;
    /** The kind of notification change. */
    kind?: Maybe<INotificationChangeType>;
};
export declare enum INotificationChangeType {
    Add = "ADD",
    Change = "CHANGE",
    Remove = "REMOVE"
}
export type INotificationInput = {
    actions?: InputMaybe<INotificationActionsInput>;
    message?: InputMaybe<INotificationMessageInput>;
    severity?: InputMaybe<INotificationSeverity>;
    source?: InputMaybe<Scalars['String']['input']>;
    sticky?: InputMaybe<Scalars['Boolean']['input']>;
};
export type INotificationMessage = {
    __typename?: 'NotificationMessage';
    links?: Maybe<Array<Maybe<IMessageLink>>>;
    original?: Maybe<INotificationMessage>;
    raw?: Maybe<Scalars['String']['output']>;
    value?: Maybe<Scalars['String']['output']>;
};
export type INotificationMessageInput = {
    links?: InputMaybe<Array<InputMaybe<IMessageLinkInput>>>;
    original?: InputMaybe<INotificationMessageInput>;
    raw?: InputMaybe<Scalars['String']['input']>;
    value?: InputMaybe<Scalars['String']['input']>;
};
export declare enum INotificationSeverity {
    Error = "Error",
    Ignore = "Ignore",
    Info = "Info",
    Warning = "Warning"
}
export type INotificationViewItem = {
    __typename?: 'NotificationViewItem';
    action?: Maybe<INotificationActions>;
    canCollapse?: Maybe<Scalars['Boolean']['output']>;
    expanded?: Maybe<Scalars['Boolean']['output']>;
    message?: Maybe<INotificationMessage>;
    progress?: Maybe<INotificationViewItemProgress>;
    severity?: Maybe<INotificationSeverity>;
    silent?: Maybe<Scalars['Boolean']['output']>;
    source?: Maybe<Scalars['String']['output']>;
    sticky?: Maybe<Scalars['Boolean']['output']>;
};
export declare enum INotificationViewItemLabelKind {
    Actions = "ACTIONS",
    Message = "MESSAGE",
    Progress = "PROGRESS",
    Severity = "SEVERITY"
}
export type INotificationViewItemProgress = {
    __typename?: 'NotificationViewItemProgress';
    state?: Maybe<INotificationViewItemProgressState>;
};
export type INotificationViewItemProgressState = {
    __typename?: 'NotificationViewItemProgressState';
    /** Indicate that the long running operation is done. */
    done?: Maybe<Scalars['Boolean']['output']>;
    /** Causes the progress bar to spin infinitely. */
    infinite?: Maybe<Scalars['Boolean']['output']>;
    /** Indicate the total amount of work. */
    total?: Maybe<Scalars['Int']['output']>;
    /** Indicate that a specific chunk of work is done. */
    worked?: Maybe<Scalars['Int']['output']>;
};
export type INotifications = {
    __typename?: 'Notifications';
    notifications?: Maybe<Array<Maybe<INotification>>>;
};
export type IOpenDocumentParamsInput = {
    textDocument?: InputMaybe<IOpenDocumentTextParamsInput>;
};
export type IOpenDocumentTextParamsInput = {
    languageId?: InputMaybe<Scalars['String']['input']>;
    text?: InputMaybe<Scalars['String']['input']>;
    uri?: InputMaybe<Scalars['String']['input']>;
    version?: InputMaybe<Scalars['Int']['input']>;
};
export type IPageInfo = {
    __typename?: 'PageInfo';
    hasNextPage: Scalars['Boolean']['output'];
};
/**
 * @lsp - Position in a text document expressed as zero-based line and character offset.
 * The offsets are based on UTF-16 string representation. So a string of the form
 * `a𐐀b` the character offset of b is 3 since `𐐀` is represented using two code
 * untis in UTF-16.
 *
 * Positions are line end character agnostic. So you can not specify a position that
 * denotes `\r|\n` or `\n"` where `|` represents the character offset.
 *
 *
 * @editor - A position in the editor.
 */
export type IPosition = {
    __typename?: 'Position';
    /**
     * @lsp - Character offset on a line in a document (zer-based). Assuming that the line is represented as a string, the
     * `character` value represents the gap between the `character` and `character+1`.
     *
     * If the character value is greater than the line length it defaults back to the
     * line length.
     * If a line number is negative, it defaults to 0.
     */
    character?: Maybe<Scalars['Int']['output']>;
    /** @editor - column (the first character in a line is between column 1 and column 2) */
    column?: Maybe<Scalars['Int']['output']>;
    /**
     * @lsp - Line position in a document (zero-based).
     * If a line number is greater than the number of lines in a document, it defaults back to the number of lines in the document.
     * If a line number is negative, it defaults to 0.
     */
    line?: Maybe<Scalars['Int']['output']>;
    /** @editor - line number (starts at 1) */
    lineNumber?: Maybe<Scalars['Int']['output']>;
};
export type IPositionInput = {
    character?: InputMaybe<Scalars['Int']['input']>;
    column?: InputMaybe<Scalars['Int']['input']>;
    line?: InputMaybe<Scalars['Int']['input']>;
    lineNumber?: InputMaybe<Scalars['Int']['input']>;
};
export type IProcessMonitoring = {
    __typename?: 'ProcessMonitoring';
    cpu?: Maybe<Scalars['Float']['output']>;
    memory?: Maybe<Scalars['Float']['output']>;
};
export type IPromptChoiceInput = {
    /**
     * Primary choices show up as buttons in the notification below the message.
     * Secondary choices show up under the gear icon in the header of the notification.
     */
    isSecondary?: InputMaybe<Scalars['Boolean']['input']>;
    /**
     * Whether to keep the notification open after the choice was selected
     * by the user. By default, will close the notification upon click.
     */
    keepOpen?: InputMaybe<Scalars['Boolean']['input']>;
    /** Label to show for the choice to the user. */
    label?: InputMaybe<Scalars['String']['input']>;
    /** Triggered when the user selects the choice. */
    run?: InputMaybe<IPromptChoiceRun>;
};
export type IPromptChoiceRun = {
    document?: InputMaybe<Scalars['AnyObject']['input']>;
    type?: InputMaybe<IGraphqlCallType>;
    variables?: InputMaybe<Scalars['AnyObject']['input']>;
};
export type IPromptOptionsCancel = {
    document?: InputMaybe<Scalars['AnyObject']['input']>;
    type?: InputMaybe<IGraphqlCallType>;
    variables?: InputMaybe<Scalars['AnyObject']['input']>;
};
export type IPromptOptionsInput = {
    /**
     * Will be called if the user closed the notification without picking
     * any  of the provided choices.
     */
    onCancel?: InputMaybe<IPromptOptionsCancel>;
    /**
     * Silent notifications are not shown to the user unless the notification center is opened.
     * The status bar will still indicate all number of notifications to
     * catch some attention.
     */
    silent?: InputMaybe<Scalars['Boolean']['input']>;
    /**
     * Sticky prompts are not automatically removed after a certain timeout.
     *
     * Note: Prompts of severity ERROR are always sticky.
     */
    sticky?: InputMaybe<Scalars['Boolean']['input']>;
};
export type IProvideTextDocumentLocationSignature = ILocation & ITextDocumentPositionParams & {
    __typename?: 'ProvideTextDocumentLocationSignature';
    position?: Maybe<IPosition>;
    range?: Maybe<IPosition>;
    rangeOrUri?: Maybe<IPosition>;
    textDocument?: Maybe<ITextDocumentIdentifier>;
    uri?: Maybe<Scalars['String']['output']>;
    uriRangeOrPosition?: Maybe<Scalars['String']['output']>;
};
export type IProvideTextDocumentLocationSignatureInput = {
    position?: InputMaybe<IPositionInput>;
    range?: InputMaybe<IPositionInput>;
    rangeOrUri?: InputMaybe<IPositionInput>;
    textDocument?: InputMaybe<ITextDocumentIdentifierInput>;
    uri?: InputMaybe<Scalars['String']['input']>;
    uriRangeOrPosition?: InputMaybe<Scalars['String']['input']>;
};
export type IQuery = {
    __typename?: 'Query';
    contextMenu?: Maybe<IContextMenu>;
    /**
     * The CDECode documentation page for the given path, used to serve the content for help
     * pages under the URL path /help on the CDECode instance. If no page exists at the path,
     * null is returned.
     */
    docSitePage?: Maybe<IDocSitePage>;
    extension?: Maybe<IRegistryExtension>;
    /**  The extension registry.  */
    extensionRegistry: IExtensionRegistry;
    extensions: IRegistryExtensionConnection;
    gallery?: Maybe<IGalleryPager>;
    galleryExtension?: Maybe<IGalleryExtension>;
    installed?: Maybe<Array<Maybe<IInstalledExtension>>>;
    instances?: Maybe<Array<Maybe<IExtensionInstance>>>;
    /** Looks up a node by ID. */
    node?: Maybe<INode>;
    notifications?: Maybe<INotifications>;
    registerProvider?: Maybe<Scalars['Boolean']['output']>;
    releases?: Maybe<Array<Maybe<IExtensionRelease>>>;
    showNotification?: Maybe<Scalars['Boolean']['output']>;
};
export type IQueryDocSitePageArgs = {
    path: Scalars['String']['input'];
};
export type IQueryExtensionArgs = {
    extensionID: Scalars['String']['input'];
};
export type IQueryExtensionsArgs = {
    first?: InputMaybe<Scalars['Int']['input']>;
    includeWIP?: InputMaybe<Scalars['Boolean']['input']>;
    local?: InputMaybe<Scalars['Boolean']['input']>;
    prioritizeExtensionIDs?: InputMaybe<Array<Scalars['String']['input']>>;
    query?: InputMaybe<Scalars['String']['input']>;
    remote?: InputMaybe<Scalars['Boolean']['input']>;
};
export type IQueryGalleryArgs = {
    query?: InputMaybe<IGalleryQueryInput>;
};
export type IQueryGalleryExtensionArgs = {
    extensionID: Scalars['String']['input'];
};
export type IQueryNodeArgs = {
    id: Scalars['ID']['input'];
};
export type IQueryRegisterProviderArgs = {
    provider?: InputMaybe<IProvideTextDocumentLocationSignatureInput>;
    registrationOptions?: InputMaybe<ITextDocumentRegistrationOptionsInput>;
};
export type IQueryReleasesArgs = {
    extensionID: Scalars['String']['input'];
};
export type IQueryShowNotificationArgs = {
    notification?: InputMaybe<INotificationInput>;
};
/**
 * @lsp - A range in a text document expressed as (zero-based) start and end positions. A range is comparable to a
 * section in an editor. Therefore the end position is exclusive. If you want to specify a range that contains a line
 * including the line ending character(s) then use an end pisition denoting the start of the next line. For example:
 * ```
 * {
 *    start: { line: 5, character: 23 },
 *    end : { line 6, character : 0 }
 * }
 * ```
 *
 * @editor - A range in the editor. This interface is suitable for serialization.
 */
export type IRange = {
    __typename?: 'Range';
    /**
     * @lsp
     * The range's end position.
     */
    end?: Maybe<IPosition>;
    /** @editor - Column on which the range ends in the line `endLineNumber` */
    endColumn?: Maybe<Scalars['Int']['output']>;
    /** @editor - Line number on which the range ends. */
    endLineNumber?: Maybe<Scalars['Int']['output']>;
    /**
     * @lsp
     * The range's start position.
     */
    start?: Maybe<IPosition>;
    /** @editor - Column on which the range starts in the line `startLineNumber` (starts at 1). */
    startColumn?: Maybe<Scalars['Int']['output']>;
    /** @editor - Line number on which the range starts (starts at 1). */
    startLineNumber?: Maybe<Scalars['Int']['output']>;
};
export type IRangeInput = {
    endColumn?: InputMaybe<Scalars['Int']['input']>;
    endLineNumber?: InputMaybe<Scalars['Int']['input']>;
    startColumn?: InputMaybe<Scalars['Int']['input']>;
    startLineNumber?: InputMaybe<Scalars['Int']['input']>;
};
export type IRegistryEntry = {
    __typename?: 'RegistryEntry';
    provider?: Maybe<Scalars['String']['output']>;
    registrationOptions?: Maybe<ITextDocumentRegistrationOptions>;
};
/**  An extenion's listing in the extension registry. */
export type IRegistryExtension = INode & {
    __typename?: 'RegistryExtension';
    activationEvents?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
    /**
     *  The qualified, unique name that refers to this extension, consisting of the registry name (if non-default),
     * publisher's name, and the extension's name, all joined by "/" (for example, "cdecode/my-extension-name").
     */
    extensionID?: Maybe<Scalars['String']['output']>;
    /**  The extension ID without the registry name. */
    extensionIDWithoutRegistry?: Maybe<Scalars['String']['output']>;
    /**
     *  The unique, opaque, permanent ID of the extension. Do not display this ID to the user; display
     * RegistryExtension.extensionID instead (it is friendlier and still unique, but it can be renamed).
     */
    id: Scalars['ID']['output'];
    /**  Whether the registry extension is published on this CDECode site. */
    isLocal?: Maybe<Scalars['Boolean']['output']>;
    /**  The extension manifest, or null if none is set. */
    manifest?: Maybe<IExtensionManifest>;
    /**  The name of the extension (not including the publisher's name). */
    name: Scalars['String']['output'];
    /**  The publisher of the extension. If this extension is from a remote registry, the publisher may be null. */
    publisher?: Maybe<IRegistryPublisher>;
    /**  Extension Releases  */
    releases?: Maybe<Array<Maybe<IExtensionRelease>>>;
    /**
     *  The URL to the extension on the extension registry where it lives (if this is a remote
     * extension). If this extension is local, then this field's value is null.
     */
    remoteURL?: Maybe<Scalars['String']['output']>;
    /**  The date when this extension was last updated on the registry. */
    updatedAt?: Maybe<Scalars['String']['output']>;
    /**  The URL to the extension on this CDECode site. */
    url?: Maybe<Scalars['String']['output']>;
    /**
     * The UUID of the extension. This identifies the extension externally (along with the origin). The UUID maps
     * 1-t0-1 to RegistryExtension.id.
     */
    uuid: Scalars['String']['output'];
    /**  Latest Published version  */
    version?: Maybe<Scalars['String']['output']>;
    /**  Whether the viewer has admin privileges on this registry extension. */
    viewerCanAdminister?: Maybe<Scalars['Boolean']['output']>;
};
/**  A list of registry extensions. */
export type IRegistryExtensionConnection = {
    __typename?: 'RegistryExtensionConnection';
    /**
     * Errors that occured while communicating with remote registries to obtain the list of extensions.
     *
     * In order to be able to return local extensions even when the remote registry is unreachable, errors are
     * recorded here instead of in the top-level GraphQL errors list.
     */
    error?: Maybe<Scalars['String']['output']>;
    /**  A list of registry extensions. */
    nodes: Array<IRegistryExtension>;
    /**  Pagination information  */
    pageInfo: IPageInfo;
    /**
     * The total count of registry extensions in the connection. This total cound may be larger than the number of
     * nodes in this object when the result is paginated.
     */
    totalCount: Scalars['Int']['output'];
    /**  location of the extension path for example: /extensions/<extension_user>/<extension_name>  */
    url?: Maybe<Scalars['String']['output']>;
};
/**  A publisher of a registry extension. */
export type IRegistryPublisher = {
    __typename?: 'RegistryPublisher';
    UserId?: Maybe<Scalars['String']['output']>;
};
/**  A list of publishers of extensions in the registry. */
export type IRegistryPublisherConnection = {
    __typename?: 'RegistryPublisherConnection';
    /**  A list of publishers. */
    nodes: Array<IRegistryPublisher>;
    /**  Pagination information. */
    pageInfo: IPageInfo;
    /**
     * The total count of publishers in the connection. This total count may be larger than the number of
     * nodes in the object when result is paginated.
     */
    totalCount: Scalars['Int']['output'];
};
export type IScripts = {
    __typename?: 'Scripts';
    cdebasebuild?: Maybe<Scalars['String']['output']>;
    cdebasepublish?: Maybe<Scalars['String']['output']>;
};
export type ISnippet = {
    __typename?: 'Snippet';
    language?: Maybe<Scalars['String']['output']>;
};
export type ISort = {
    key: Scalars['String']['input'];
    value: ISortEnum;
};
export declare enum ISortEnum {
    Asc = "ASC",
    Desc = "DESC"
}
export type ISubscription = {
    __typename?: 'Subscription';
    dummy?: Maybe<Scalars['Int']['output']>;
};
export type ITextDocumentIdentifier = IITextDocumentIdentifier & {
    __typename?: 'TextDocumentIdentifier';
    languageId?: Maybe<Scalars['String']['output']>;
    uri?: Maybe<Scalars['URI']['output']>;
};
export type ITextDocumentIdentifierInput = {
    uri?: InputMaybe<Scalars['URI']['input']>;
};
/** An item to transfer a text document from the client to the server. */
export type ITextDocumentItem = IITextDocumentIdentifier & {
    __typename?: 'TextDocumentItem';
    /** The ID of the document's language. This is a well-defined string identifier such as "phython". */
    languageId?: Maybe<Scalars['String']['output']>;
    /** The document's text content. */
    text?: Maybe<Scalars['String']['output']>;
    uri?: Maybe<Scalars['URI']['output']>;
};
export type ITextDocumentItemInput = {
    languageId?: InputMaybe<Scalars['String']['input']>;
    text?: InputMaybe<Scalars['String']['input']>;
    uri?: InputMaybe<Scalars['String']['input']>;
};
export type ITextDocumentPositionParams = {
    position?: Maybe<IPosition>;
    textDocument?: Maybe<ITextDocumentIdentifier>;
};
export type ITextDocumentPositionParamsInput = {
    position?: InputMaybe<IPositionInput>;
    textDocument?: InputMaybe<ITextDocumentIdentifierInput>;
};
export type ITextDocumentRegistrationOptions = {
    __typename?: 'TextDocumentRegistrationOptions';
    documentSelector?: Maybe<Array<Maybe<Scalars['String']['output']>>>;
};
export type ITextDocumentRegistrationOptionsInput = {
    documentSelector?: InputMaybe<Array<InputMaybe<Scalars['String']['input']>>>;
};
export type IThemeLabel = {
    __typename?: 'ThemeLabel';
    label?: Maybe<Scalars['String']['output']>;
    path?: Maybe<Scalars['String']['output']>;
    uiTheme?: Maybe<Scalars['String']['output']>;
};
export type IViewContainer = {
    __typename?: 'ViewContainer';
    id?: Maybe<Scalars['ID']['output']>;
    title?: Maybe<Scalars['String']['output']>;
};
export type ICopyMutationVariables = Exact<{
    value?: InputMaybe<Scalars['String']['input']>;
}>;
export type ICopyMutation = {
    __typename?: 'Mutation';
    copy?: boolean | null;
};
export type IRunMenuActionMutationVariables = Exact<{
    argument?: InputMaybe<IContributionActionRunInput>;
}>;
export type IRunMenuActionMutation = {
    __typename?: 'Mutation';
    runMenuAction?: boolean | null;
};
export type IHideContextMenuMutationVariables = Exact<{
    [key: string]: never;
}>;
export type IHideContextMenuMutation = {
    __typename?: 'Mutation';
    hideContextMenu?: boolean | null;
};
export type IShowContextMenuMutationVariables = Exact<{
    delegate?: InputMaybe<IContextMenuInput>;
}>;
export type IShowContextMenuMutation = {
    __typename?: 'Mutation';
    showContextMenu?: boolean | null;
};
export type IInstallMutationVariables = Exact<{
    vsix: Scalars['String']['input'];
}>;
export type IInstallMutation = {
    __typename?: 'Mutation';
    install?: {
        __typename?: 'ExtensionIdentifier';
        id?: string | null;
        uuid?: string | null;
    } | null;
};
export type IProviderDefinitionMutationVariables = Exact<{
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
}>;
export type IProviderDefinitionMutation = {
    __typename?: 'Mutation';
    hoverProviderDefinition?: any | null;
};
export type IRemoveMutationVariables = Exact<{
    id: Scalars['String']['input'];
}>;
export type IRemoveMutation = {
    __typename?: 'Mutation';
    removeExtension?: boolean | null;
};
export type IContextMenuQueryVariables = Exact<{
    [key: string]: never;
}>;
export type IContextMenuQuery = {
    __typename?: 'Query';
    contextMenu?: {
        __typename?: 'ContextMenu';
        id?: string | null;
        isShow?: boolean | null;
        anchor?: {
            __typename?: 'Anchor';
            x?: number | null;
            y?: number | null;
            height?: number | null;
            width?: number | null;
        } | null;
        menuItems?: Array<{
            __typename?: 'MenuItem';
            id?: string | null;
            label?: string | null;
            enabled?: boolean | null;
            run?: {
                __typename?: 'ContributionActionRun';
                type?: IGraphqlCallType | null;
                document?: any | null;
                variables?: any | null;
            } | null;
        } | null> | null;
    } | null;
};
export type IGalleryExtensionQueryVariables = Exact<{
    extensionID: Scalars['String']['input'];
}>;
export type IGalleryExtensionQuery = {
    __typename?: 'Query';
    galleryExtension?: {
        __typename?: 'GalleryExtension';
        id?: string | null;
        name?: string | null;
        icon?: string | null;
        version?: string | null;
        description?: string | null;
        publisher?: string | null;
        installCount?: number | null;
        publisherDisplayName?: string | null;
        rating?: number | null;
        ratingCount?: number | null;
        displayName?: string | null;
        assets?: {
            __typename?: 'GalleryExtensionAssets';
            download?: {
                __typename?: 'GalleryExtensionAsset';
                uri?: string | null;
                fallbackUri?: string | null;
            } | null;
        } | null;
        resources?: {
            __typename?: 'GalleryExtensionResources';
            icon?: string | null;
            readme?: string | null;
            manifest?: string | null;
            changelog?: string | null;
        } | null;
    } | null;
};
export type IExtensionsByLimitQueryVariables = Exact<{
    first: Scalars['Int']['input'];
    prioritizeExtensionIDs: Array<Scalars['String']['input']> | Scalars['String']['input'];
}>;
export type IExtensionsByLimitQuery = {
    __typename?: 'Query';
    extensions: {
        __typename?: 'RegistryExtensionConnection';
        nodes: Array<{
            __typename?: 'RegistryExtension';
            id: string;
            url?: string | null;
            extensionID?: string | null;
            viewerCanAdminister?: boolean | null;
            manifest?: {
                __typename?: 'ExtensionManifest';
                bundleURL?: string | null;
                raw?: string | null;
                name?: string | null;
                activationEvents?: Array<string | null> | null;
            } | null;
        }>;
    };
};
export type IGalleryQueryVariables = Exact<{
    query?: InputMaybe<IGalleryQueryInput>;
}>;
export type IGalleryQuery = {
    __typename?: 'Query';
    gallery?: {
        __typename?: 'GalleryPager';
        page?: number | null;
        firstPage?: Array<{
            __typename?: 'GalleryExtension';
            id?: string | null;
            name?: string | null;
            icon?: string | null;
            version?: string | null;
            description?: string | null;
            publisher?: string | null;
            installCount?: number | null;
            publisherDisplayName?: string | null;
            rating?: number | null;
            ratingCount?: number | null;
            displayName?: string | null;
            assets?: {
                __typename?: 'GalleryExtensionAssets';
                download?: {
                    __typename?: 'GalleryExtensionAsset';
                    uri?: string | null;
                    fallbackUri?: string | null;
                } | null;
            } | null;
        } | null> | null;
    } | null;
};
export type IInstalledExtensionsQueryVariables = Exact<{
    [key: string]: never;
}>;
export type IInstalledExtensionsQuery = {
    __typename?: 'Query';
    installed?: Array<{
        __typename?: 'InstalledExtension';
        identifier?: {
            __typename?: 'ExtensionIdentifier';
            id?: string | null;
            uuid?: string | null;
        } | null;
        galleryIdentifier?: {
            __typename?: 'ExtensionIdentifier';
            id?: string | null;
            uuid?: string | null;
        } | null;
        extension?: {
            __typename?: 'GalleryExtension';
            name?: string | null;
            id?: string | null;
            icon?: string | null;
            displayName?: string | null;
            installCount?: number | null;
            description?: string | null;
            version?: string | null;
            publisherDisplayName?: string | null;
            identifier?: {
                __typename?: 'ExtensionIdentifier';
                id?: string | null;
                uuid?: string | null;
            } | null;
        } | null;
    } | null> | null;
};
export type INotificationsQueryVariables = Exact<{
    [key: string]: never;
}>;
export type INotificationsQuery = {
    __typename?: 'Query';
    notifications?: {
        __typename?: 'Notifications';
        notifications?: Array<{
            __typename?: 'Notification';
            index?: boolean | null;
            severity?: INotificationSeverity | null;
            message?: string | null;
            sticky?: boolean | null;
            actions?: {
                __typename?: 'NotificationActions';
                primary?: Array<{
                    __typename?: 'ContributionAction';
                    id?: string | null;
                    label?: string | null;
                    tooltip?: string | null;
                    class?: string | null;
                    enabled?: boolean | null;
                    checked?: boolean | null;
                    radio?: boolean | null;
                    run?: {
                        __typename?: 'ContributionActionRun';
                        type?: IGraphqlCallType | null;
                        document?: any | null;
                        variables?: any | null;
                    } | null;
                } | null> | null;
                secondary?: Array<{
                    __typename?: 'ContributionAction';
                    id?: string | null;
                    label?: string | null;
                    tooltip?: string | null;
                    class?: string | null;
                    enabled?: boolean | null;
                    checked?: boolean | null;
                    radio?: boolean | null;
                    run?: {
                        __typename?: 'ContributionActionRun';
                        type?: IGraphqlCallType | null;
                        document?: any | null;
                        variables?: any | null;
                    } | null;
                } | null> | null;
            } | null;
        } | null> | null;
    } | null;
};
export type IShowNotificationQueryVariables = Exact<{
    notification?: InputMaybe<INotificationInput>;
}>;
export type IShowNotificationQuery = {
    __typename?: 'Query';
    showNotification?: boolean | null;
};
export declare const CopyDocument: DocumentNode;
export type ICopyMutationFn = Apollo.MutationFunction<ICopyMutation, ICopyMutationVariables>;
/**
 * __useCopyMutation__
 *
 * To run a mutation, you first call `useCopyMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useCopyMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [copyMutation, { data, loading, error }] = useCopyMutation({
 *   variables: {
 *      value: // value for 'value'
 *   },
 * });
 */
export declare function useCopyMutation(baseOptions?: Apollo.MutationHookOptions<ICopyMutation, ICopyMutationVariables>): Apollo.MutationTuple<ICopyMutation, Exact<{
    value?: InputMaybe<Scalars["String"]["input"]>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type CopyMutationHookResult = ReturnType<typeof useCopyMutation>;
export type CopyMutationResult = Apollo.MutationResult<ICopyMutation>;
export type CopyMutationOptions = Apollo.BaseMutationOptions<ICopyMutation, ICopyMutationVariables>;
export declare const RunMenuActionDocument: DocumentNode;
export type IRunMenuActionMutationFn = Apollo.MutationFunction<IRunMenuActionMutation, IRunMenuActionMutationVariables>;
/**
 * __useRunMenuActionMutation__
 *
 * To run a mutation, you first call `useRunMenuActionMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useRunMenuActionMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [runMenuActionMutation, { data, loading, error }] = useRunMenuActionMutation({
 *   variables: {
 *      argument: // value for 'argument'
 *   },
 * });
 */
export declare function useRunMenuActionMutation(baseOptions?: Apollo.MutationHookOptions<IRunMenuActionMutation, IRunMenuActionMutationVariables>): Apollo.MutationTuple<IRunMenuActionMutation, Exact<{
    argument?: InputMaybe<IContributionActionRunInput>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type RunMenuActionMutationHookResult = ReturnType<typeof useRunMenuActionMutation>;
export type RunMenuActionMutationResult = Apollo.MutationResult<IRunMenuActionMutation>;
export type RunMenuActionMutationOptions = Apollo.BaseMutationOptions<IRunMenuActionMutation, IRunMenuActionMutationVariables>;
export declare const HideContextMenuDocument: DocumentNode;
export type IHideContextMenuMutationFn = Apollo.MutationFunction<IHideContextMenuMutation, IHideContextMenuMutationVariables>;
/**
 * __useHideContextMenuMutation__
 *
 * To run a mutation, you first call `useHideContextMenuMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useHideContextMenuMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [hideContextMenuMutation, { data, loading, error }] = useHideContextMenuMutation({
 *   variables: {
 *   },
 * });
 */
export declare function useHideContextMenuMutation(baseOptions?: Apollo.MutationHookOptions<IHideContextMenuMutation, IHideContextMenuMutationVariables>): Apollo.MutationTuple<IHideContextMenuMutation, Exact<{
    [key: string]: never;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type HideContextMenuMutationHookResult = ReturnType<typeof useHideContextMenuMutation>;
export type HideContextMenuMutationResult = Apollo.MutationResult<IHideContextMenuMutation>;
export type HideContextMenuMutationOptions = Apollo.BaseMutationOptions<IHideContextMenuMutation, IHideContextMenuMutationVariables>;
export declare const ShowContextMenuDocument: DocumentNode;
export type IShowContextMenuMutationFn = Apollo.MutationFunction<IShowContextMenuMutation, IShowContextMenuMutationVariables>;
/**
 * __useShowContextMenuMutation__
 *
 * To run a mutation, you first call `useShowContextMenuMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useShowContextMenuMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [showContextMenuMutation, { data, loading, error }] = useShowContextMenuMutation({
 *   variables: {
 *      delegate: // value for 'delegate'
 *   },
 * });
 */
export declare function useShowContextMenuMutation(baseOptions?: Apollo.MutationHookOptions<IShowContextMenuMutation, IShowContextMenuMutationVariables>): Apollo.MutationTuple<IShowContextMenuMutation, Exact<{
    delegate?: InputMaybe<IContextMenuInput>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type ShowContextMenuMutationHookResult = ReturnType<typeof useShowContextMenuMutation>;
export type ShowContextMenuMutationResult = Apollo.MutationResult<IShowContextMenuMutation>;
export type ShowContextMenuMutationOptions = Apollo.BaseMutationOptions<IShowContextMenuMutation, IShowContextMenuMutationVariables>;
export declare const InstallDocument: DocumentNode;
export type IInstallMutationFn = Apollo.MutationFunction<IInstallMutation, IInstallMutationVariables>;
/**
 * __useInstallMutation__
 *
 * To run a mutation, you first call `useInstallMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useInstallMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [installMutation, { data, loading, error }] = useInstallMutation({
 *   variables: {
 *      vsix: // value for 'vsix'
 *   },
 * });
 */
export declare function useInstallMutation(baseOptions?: Apollo.MutationHookOptions<IInstallMutation, IInstallMutationVariables>): Apollo.MutationTuple<IInstallMutation, Exact<{
    vsix: Scalars["String"]["input"];
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type InstallMutationHookResult = ReturnType<typeof useInstallMutation>;
export type InstallMutationResult = Apollo.MutationResult<IInstallMutation>;
export type InstallMutationOptions = Apollo.BaseMutationOptions<IInstallMutation, IInstallMutationVariables>;
export declare const ProviderDefinitionDocument: DocumentNode;
export type IProviderDefinitionMutationFn = Apollo.MutationFunction<IProviderDefinitionMutation, IProviderDefinitionMutationVariables>;
/**
 * __useProviderDefinitionMutation__
 *
 * To run a mutation, you first call `useProviderDefinitionMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useProviderDefinitionMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [providerDefinitionMutation, { data, loading, error }] = useProviderDefinitionMutation({
 *   variables: {
 *      params: // value for 'params'
 *   },
 * });
 */
export declare function useProviderDefinitionMutation(baseOptions?: Apollo.MutationHookOptions<IProviderDefinitionMutation, IProviderDefinitionMutationVariables>): Apollo.MutationTuple<IProviderDefinitionMutation, Exact<{
    params?: InputMaybe<ITextDocumentPositionParamsInput>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type ProviderDefinitionMutationHookResult = ReturnType<typeof useProviderDefinitionMutation>;
export type ProviderDefinitionMutationResult = Apollo.MutationResult<IProviderDefinitionMutation>;
export type ProviderDefinitionMutationOptions = Apollo.BaseMutationOptions<IProviderDefinitionMutation, IProviderDefinitionMutationVariables>;
export declare const RemoveDocument: DocumentNode;
export type IRemoveMutationFn = Apollo.MutationFunction<IRemoveMutation, IRemoveMutationVariables>;
/**
 * __useRemoveMutation__
 *
 * To run a mutation, you first call `useRemoveMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useRemoveMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [removeMutation, { data, loading, error }] = useRemoveMutation({
 *   variables: {
 *      id: // value for 'id'
 *   },
 * });
 */
export declare function useRemoveMutation(baseOptions?: Apollo.MutationHookOptions<IRemoveMutation, IRemoveMutationVariables>): Apollo.MutationTuple<IRemoveMutation, Exact<{
    id: Scalars["String"]["input"];
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type RemoveMutationHookResult = ReturnType<typeof useRemoveMutation>;
export type RemoveMutationResult = Apollo.MutationResult<IRemoveMutation>;
export type RemoveMutationOptions = Apollo.BaseMutationOptions<IRemoveMutation, IRemoveMutationVariables>;
export declare const ContextMenuDocument: DocumentNode;
/**
 * __useContextMenuQuery__
 *
 * To run a query within a React component, call `useContextMenuQuery` and pass it any options that fit your needs.
 * When your component renders, `useContextMenuQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useContextMenuQuery({
 *   variables: {
 *   },
 * });
 */
export declare function useContextMenuQuery(baseOptions?: Apollo.QueryHookOptions<IContextMenuQuery, IContextMenuQueryVariables>): Apollo.QueryResult<IContextMenuQuery, Exact<{
    [key: string]: never;
}>>;
export declare function useContextMenuLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<IContextMenuQuery, IContextMenuQueryVariables>): Apollo.LazyQueryResultTuple<IContextMenuQuery, Exact<{
    [key: string]: never;
}>>;
export declare function useContextMenuSuspenseQuery(baseOptions?: Apollo.SkipToken | Apollo.SuspenseQueryHookOptions<IContextMenuQuery, IContextMenuQueryVariables>): Apollo.UseSuspenseQueryResult<IContextMenuQuery, Exact<{
    [key: string]: never;
}>>;
export type ContextMenuQueryHookResult = ReturnType<typeof useContextMenuQuery>;
export type ContextMenuLazyQueryHookResult = ReturnType<typeof useContextMenuLazyQuery>;
export type ContextMenuSuspenseQueryHookResult = ReturnType<typeof useContextMenuSuspenseQuery>;
export type ContextMenuQueryResult = Apollo.QueryResult<IContextMenuQuery, IContextMenuQueryVariables>;
export declare const GalleryExtensionDocument: DocumentNode;
/**
 * __useGalleryExtensionQuery__
 *
 * To run a query within a React component, call `useGalleryExtensionQuery` and pass it any options that fit your needs.
 * When your component renders, `useGalleryExtensionQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useGalleryExtensionQuery({
 *   variables: {
 *      extensionID: // value for 'extensionID'
 *   },
 * });
 */
export declare function useGalleryExtensionQuery(baseOptions: Apollo.QueryHookOptions<IGalleryExtensionQuery, IGalleryExtensionQueryVariables> & ({
    variables: IGalleryExtensionQueryVariables;
    skip?: boolean;
} | {
    skip: boolean;
})): Apollo.QueryResult<IGalleryExtensionQuery, Exact<{
    extensionID: Scalars["String"]["input"];
}>>;
export declare function useGalleryExtensionLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<IGalleryExtensionQuery, IGalleryExtensionQueryVariables>): Apollo.LazyQueryResultTuple<IGalleryExtensionQuery, Exact<{
    extensionID: Scalars["String"]["input"];
}>>;
export declare function useGalleryExtensionSuspenseQuery(baseOptions?: Apollo.SkipToken | Apollo.SuspenseQueryHookOptions<IGalleryExtensionQuery, IGalleryExtensionQueryVariables>): Apollo.UseSuspenseQueryResult<IGalleryExtensionQuery, Exact<{
    extensionID: Scalars["String"]["input"];
}>>;
export type GalleryExtensionQueryHookResult = ReturnType<typeof useGalleryExtensionQuery>;
export type GalleryExtensionLazyQueryHookResult = ReturnType<typeof useGalleryExtensionLazyQuery>;
export type GalleryExtensionSuspenseQueryHookResult = ReturnType<typeof useGalleryExtensionSuspenseQuery>;
export type GalleryExtensionQueryResult = Apollo.QueryResult<IGalleryExtensionQuery, IGalleryExtensionQueryVariables>;
export declare const ExtensionsByLimitDocument: DocumentNode;
/**
 * __useExtensionsByLimitQuery__
 *
 * To run a query within a React component, call `useExtensionsByLimitQuery` and pass it any options that fit your needs.
 * When your component renders, `useExtensionsByLimitQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useExtensionsByLimitQuery({
 *   variables: {
 *      first: // value for 'first'
 *      prioritizeExtensionIDs: // value for 'prioritizeExtensionIDs'
 *   },
 * });
 */
export declare function useExtensionsByLimitQuery(baseOptions: Apollo.QueryHookOptions<IExtensionsByLimitQuery, IExtensionsByLimitQueryVariables> & ({
    variables: IExtensionsByLimitQueryVariables;
    skip?: boolean;
} | {
    skip: boolean;
})): Apollo.QueryResult<IExtensionsByLimitQuery, Exact<{
    first: Scalars["Int"]["input"];
    prioritizeExtensionIDs: Array<Scalars["String"]["input"]> | Scalars["String"]["input"];
}>>;
export declare function useExtensionsByLimitLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<IExtensionsByLimitQuery, IExtensionsByLimitQueryVariables>): Apollo.LazyQueryResultTuple<IExtensionsByLimitQuery, Exact<{
    first: Scalars["Int"]["input"];
    prioritizeExtensionIDs: Array<Scalars["String"]["input"]> | Scalars["String"]["input"];
}>>;
export declare function useExtensionsByLimitSuspenseQuery(baseOptions?: Apollo.SkipToken | Apollo.SuspenseQueryHookOptions<IExtensionsByLimitQuery, IExtensionsByLimitQueryVariables>): Apollo.UseSuspenseQueryResult<IExtensionsByLimitQuery, Exact<{
    first: Scalars["Int"]["input"];
    prioritizeExtensionIDs: Array<Scalars["String"]["input"]> | Scalars["String"]["input"];
}>>;
export type ExtensionsByLimitQueryHookResult = ReturnType<typeof useExtensionsByLimitQuery>;
export type ExtensionsByLimitLazyQueryHookResult = ReturnType<typeof useExtensionsByLimitLazyQuery>;
export type ExtensionsByLimitSuspenseQueryHookResult = ReturnType<typeof useExtensionsByLimitSuspenseQuery>;
export type ExtensionsByLimitQueryResult = Apollo.QueryResult<IExtensionsByLimitQuery, IExtensionsByLimitQueryVariables>;
export declare const GalleryDocument: DocumentNode;
/**
 * __useGalleryQuery__
 *
 * To run a query within a React component, call `useGalleryQuery` and pass it any options that fit your needs.
 * When your component renders, `useGalleryQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useGalleryQuery({
 *   variables: {
 *      query: // value for 'query'
 *   },
 * });
 */
export declare function useGalleryQuery(baseOptions?: Apollo.QueryHookOptions<IGalleryQuery, IGalleryQueryVariables>): Apollo.QueryResult<IGalleryQuery, Exact<{
    query?: InputMaybe<IGalleryQueryInput>;
}>>;
export declare function useGalleryLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<IGalleryQuery, IGalleryQueryVariables>): Apollo.LazyQueryResultTuple<IGalleryQuery, Exact<{
    query?: InputMaybe<IGalleryQueryInput>;
}>>;
export declare function useGallerySuspenseQuery(baseOptions?: Apollo.SkipToken | Apollo.SuspenseQueryHookOptions<IGalleryQuery, IGalleryQueryVariables>): Apollo.UseSuspenseQueryResult<IGalleryQuery, Exact<{
    query?: InputMaybe<IGalleryQueryInput>;
}>>;
export type GalleryQueryHookResult = ReturnType<typeof useGalleryQuery>;
export type GalleryLazyQueryHookResult = ReturnType<typeof useGalleryLazyQuery>;
export type GallerySuspenseQueryHookResult = ReturnType<typeof useGallerySuspenseQuery>;
export type GalleryQueryResult = Apollo.QueryResult<IGalleryQuery, IGalleryQueryVariables>;
export declare const InstalledExtensionsDocument: DocumentNode;
/**
 * __useInstalledExtensionsQuery__
 *
 * To run a query within a React component, call `useInstalledExtensionsQuery` and pass it any options that fit your needs.
 * When your component renders, `useInstalledExtensionsQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useInstalledExtensionsQuery({
 *   variables: {
 *   },
 * });
 */
export declare function useInstalledExtensionsQuery(baseOptions?: Apollo.QueryHookOptions<IInstalledExtensionsQuery, IInstalledExtensionsQueryVariables>): Apollo.QueryResult<IInstalledExtensionsQuery, Exact<{
    [key: string]: never;
}>>;
export declare function useInstalledExtensionsLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<IInstalledExtensionsQuery, IInstalledExtensionsQueryVariables>): Apollo.LazyQueryResultTuple<IInstalledExtensionsQuery, Exact<{
    [key: string]: never;
}>>;
export declare function useInstalledExtensionsSuspenseQuery(baseOptions?: Apollo.SkipToken | Apollo.SuspenseQueryHookOptions<IInstalledExtensionsQuery, IInstalledExtensionsQueryVariables>): Apollo.UseSuspenseQueryResult<IInstalledExtensionsQuery, Exact<{
    [key: string]: never;
}>>;
export type InstalledExtensionsQueryHookResult = ReturnType<typeof useInstalledExtensionsQuery>;
export type InstalledExtensionsLazyQueryHookResult = ReturnType<typeof useInstalledExtensionsLazyQuery>;
export type InstalledExtensionsSuspenseQueryHookResult = ReturnType<typeof useInstalledExtensionsSuspenseQuery>;
export type InstalledExtensionsQueryResult = Apollo.QueryResult<IInstalledExtensionsQuery, IInstalledExtensionsQueryVariables>;
export declare const NotificationsDocument: DocumentNode;
/**
 * __useNotificationsQuery__
 *
 * To run a query within a React component, call `useNotificationsQuery` and pass it any options that fit your needs.
 * When your component renders, `useNotificationsQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useNotificationsQuery({
 *   variables: {
 *   },
 * });
 */
export declare function useNotificationsQuery(baseOptions?: Apollo.QueryHookOptions<INotificationsQuery, INotificationsQueryVariables>): Apollo.QueryResult<INotificationsQuery, Exact<{
    [key: string]: never;
}>>;
export declare function useNotificationsLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<INotificationsQuery, INotificationsQueryVariables>): Apollo.LazyQueryResultTuple<INotificationsQuery, Exact<{
    [key: string]: never;
}>>;
export declare function useNotificationsSuspenseQuery(baseOptions?: Apollo.SkipToken | Apollo.SuspenseQueryHookOptions<INotificationsQuery, INotificationsQueryVariables>): Apollo.UseSuspenseQueryResult<INotificationsQuery, Exact<{
    [key: string]: never;
}>>;
export type NotificationsQueryHookResult = ReturnType<typeof useNotificationsQuery>;
export type NotificationsLazyQueryHookResult = ReturnType<typeof useNotificationsLazyQuery>;
export type NotificationsSuspenseQueryHookResult = ReturnType<typeof useNotificationsSuspenseQuery>;
export type NotificationsQueryResult = Apollo.QueryResult<INotificationsQuery, INotificationsQueryVariables>;
export declare const ShowNotificationDocument: DocumentNode;
/**
 * __useShowNotificationQuery__
 *
 * To run a query within a React component, call `useShowNotificationQuery` and pass it any options that fit your needs.
 * When your component renders, `useShowNotificationQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useShowNotificationQuery({
 *   variables: {
 *      notification: // value for 'notification'
 *   },
 * });
 */
export declare function useShowNotificationQuery(baseOptions?: Apollo.QueryHookOptions<IShowNotificationQuery, IShowNotificationQueryVariables>): Apollo.QueryResult<IShowNotificationQuery, Exact<{
    notification?: InputMaybe<INotificationInput>;
}>>;
export declare function useShowNotificationLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<IShowNotificationQuery, IShowNotificationQueryVariables>): Apollo.LazyQueryResultTuple<IShowNotificationQuery, Exact<{
    notification?: InputMaybe<INotificationInput>;
}>>;
export declare function useShowNotificationSuspenseQuery(baseOptions?: Apollo.SkipToken | Apollo.SuspenseQueryHookOptions<IShowNotificationQuery, IShowNotificationQueryVariables>): Apollo.UseSuspenseQueryResult<IShowNotificationQuery, Exact<{
    notification?: InputMaybe<INotificationInput>;
}>>;
export type ShowNotificationQueryHookResult = ReturnType<typeof useShowNotificationQuery>;
export type ShowNotificationLazyQueryHookResult = ReturnType<typeof useShowNotificationLazyQuery>;
export type ShowNotificationSuspenseQueryHookResult = ReturnType<typeof useShowNotificationSuspenseQuery>;
export type ShowNotificationQueryResult = Apollo.QueryResult<IShowNotificationQuery, IShowNotificationQueryVariables>;
export type ResolverTypeWrapper<T> = Promise<T> | T;
export type ResolverWithResolve<TResult, TParent, TContext, TArgs> = {
    resolve: ResolverFn<TResult, TParent, TContext, TArgs>;
};
export type Resolver<TResult, TParent = {}, TContext = {}, TArgs = {}> = ResolverFn<TResult, TParent, TContext, TArgs> | ResolverWithResolve<TResult, TParent, TContext, TArgs>;
export type ResolverFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => Promise<TResult> | TResult;
export type SubscriptionSubscribeFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => AsyncIterable<TResult> | Promise<AsyncIterable<TResult>>;
export type SubscriptionResolveFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
export interface SubscriptionSubscriberObject<TResult, TKey extends string, TParent, TContext, TArgs> {
    subscribe: SubscriptionSubscribeFn<{
        [key in TKey]: TResult;
    }, TParent, TContext, TArgs>;
    resolve?: SubscriptionResolveFn<TResult, {
        [key in TKey]: TResult;
    }, TContext, TArgs>;
}
export interface SubscriptionResolverObject<TResult, TParent, TContext, TArgs> {
    subscribe: SubscriptionSubscribeFn<any, TParent, TContext, TArgs>;
    resolve: SubscriptionResolveFn<TResult, any, TContext, TArgs>;
}
export type SubscriptionObject<TResult, TKey extends string, TParent, TContext, TArgs> = SubscriptionSubscriberObject<TResult, TKey, TParent, TContext, TArgs> | SubscriptionResolverObject<TResult, TParent, TContext, TArgs>;
export type SubscriptionResolver<TResult, TKey extends string, TParent = {}, TContext = {}, TArgs = {}> = ((...args: any[]) => SubscriptionObject<TResult, TKey, TParent, TContext, TArgs>) | SubscriptionObject<TResult, TKey, TParent, TContext, TArgs>;
export type TypeResolveFn<TTypes, TParent = {}, TContext = {}> = (parent: TParent, context: TContext, info: GraphQLResolveInfo) => Maybe<TTypes> | Promise<Maybe<TTypes>>;
export type IsTypeOfResolverFn<T = {}, TContext = {}> = (obj: T, context: TContext, info: GraphQLResolveInfo) => boolean | Promise<boolean>;
export type NextResolverFn<T> = () => Promise<T>;
export type DirectiveResolverFn<TResult = {}, TParent = {}, TContext = {}, TArgs = {}> = (next: NextResolverFn<TResult>, parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
/** Mapping of interface types */
export type IResolversInterfaceTypes<_RefType extends Record<string, unknown>> = {
    Hover: never;
    IResourceUtilizationSettings: never;
    ITextDocumentIdentifier: (ITextDocumentIdentifier) | (ITextDocumentItem);
    Location: (IProvideTextDocumentLocationSignature);
    MarkupContent: never;
    Node: (IRegistryExtension);
    TextDocumentPositionParams: (IProvideTextDocumentLocationSignature);
};
/** Mapping between all available schema types and the resolvers types */
export type IResolversTypes = {
    AdminIdeSettings: ResolverTypeWrapper<IAdminIdeSettings>;
    Anchor: ResolverTypeWrapper<IAnchor>;
    AnchorInput: IAnchorInput;
    AnyObject: ResolverTypeWrapper<Scalars['AnyObject']['output']>;
    ArgsType: ResolverTypeWrapper<IArgsType>;
    Assets: ResolverTypeWrapper<IAssets>;
    Author: ResolverTypeWrapper<IAuthor>;
    BaseExtension: ResolverTypeWrapper<IBaseExtension>;
    Boolean: ResolverTypeWrapper<Scalars['Boolean']['output']>;
    Bundles: ResolverTypeWrapper<IBundles>;
    ClientContainerService: IClientContainerService;
    CommandHandlerDescriptionType: ResolverTypeWrapper<ICommandHandlerDescriptionType>;
    CommandType: ResolverTypeWrapper<ICommandType>;
    CommandsType: ResolverTypeWrapper<ICommandsType>;
    ContextMenu: ResolverTypeWrapper<IContextMenu>;
    ContextMenuInput: IContextMenuInput;
    Contributes: ResolverTypeWrapper<IContributes>;
    ContributionAction: ResolverTypeWrapper<IContributionAction>;
    ContributionActionInput: IContributionActionInput;
    ContributionActionItem: ResolverTypeWrapper<IContributionActionItem>;
    ContributionActionRun: ResolverTypeWrapper<IContributionActionRun>;
    ContributionActionRunInput: IContributionActionRunInput;
    ContributionActions: ResolverTypeWrapper<IContributionActions>;
    ContributionView: ResolverTypeWrapper<IContributionView>;
    Date: ResolverTypeWrapper<Scalars['Date']['output']>;
    DateTime: ResolverTypeWrapper<Scalars['DateTime']['output']>;
    Debugger: ResolverTypeWrapper<IDebugger>;
    DocSitePage: ResolverTypeWrapper<IDocSitePage>;
    DocumentFilter: ResolverTypeWrapper<IDocumentFilter>;
    EmptyResponse: ResolverTypeWrapper<IEmptyResponse>;
    Engines: ResolverTypeWrapper<IEngines>;
    Environment: ResolverTypeWrapper<IEnvironment>;
    EnvironmentPayload: IEnvironmentPayload;
    EnvironmentSync: IEnvironmentSync;
    ExtensionColor: ResolverTypeWrapper<IExtensionColor>;
    ExtensionColorTypes: ResolverTypeWrapper<IExtensionColorTypes>;
    ExtensionConfiguration: ResolverTypeWrapper<IExtensionConfiguration>;
    ExtensionConfigurationProperty: ResolverTypeWrapper<IExtensionConfigurationProperty>;
    ExtensionContributions: ResolverTypeWrapper<IExtensionContributions>;
    ExtensionIdentifier: ResolverTypeWrapper<IExtensionIdentifier>;
    ExtensionInstance: ResolverTypeWrapper<IExtensionInstance>;
    ExtensionJSONValidation: ResolverTypeWrapper<IExtensionJsonValidation>;
    ExtensionKind: IExtensionKind;
    ExtensionLanguage: ResolverTypeWrapper<IExtensionLanguage>;
    ExtensionManifest: ResolverTypeWrapper<IExtensionManifest>;
    ExtensionManifestBugs: ResolverTypeWrapper<IExtensionManifestBugs>;
    ExtensionManifestRepository: ResolverTypeWrapper<IExtensionManifestRepository>;
    ExtensionPackageType: ResolverTypeWrapper<IExtensionPackageType>;
    ExtensionRegistry: ResolverTypeWrapper<IExtensionRegistry>;
    ExtensionRegistryCreateExtensionResult: ResolverTypeWrapper<IExtensionRegistryCreateExtensionResult>;
    ExtensionRegistryPublishExtensionResult: ResolverTypeWrapper<IExtensionRegistryPublishExtensionResult>;
    ExtensionRegistryUpdateExtensionResult: ResolverTypeWrapper<IExtensionRegistryUpdateExtensionResult>;
    ExtensionRelease: ResolverTypeWrapper<IExtensionRelease>;
    ExtensionType: IExtensionType;
    FieldError: ResolverTypeWrapper<IFieldError>;
    Float: ResolverTypeWrapper<Scalars['Float']['output']>;
    GalleryBanner: ResolverTypeWrapper<IGalleryBanner>;
    GalleryExtension: ResolverTypeWrapper<IGalleryExtension>;
    GalleryExtensionAsset: ResolverTypeWrapper<IGalleryExtensionAsset>;
    GalleryExtensionAssets: ResolverTypeWrapper<IGalleryExtensionAssets>;
    GalleryExtensionProperties: ResolverTypeWrapper<IGalleryExtensionProperties>;
    GalleryExtensionResources: ResolverTypeWrapper<IGalleryExtensionResources>;
    GalleryFilter: IGalleryFilter;
    GalleryPager: ResolverTypeWrapper<IGalleryPager>;
    GalleryQueryInput: IGalleryQueryInput;
    GeoLocation: ResolverTypeWrapper<IGeoLocation>;
    Grammar: ResolverTypeWrapper<IGrammar>;
    GraphqlCallType: IGraphqlCallType;
    Hover: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['Hover']>;
    IActivationRequest: IIActivationRequest;
    IBehaviorSubject: ResolverTypeWrapper<IIBehaviorSubject>;
    IBehaviorSubjectValue: ResolverTypeWrapper<IIBehaviorSubjectValue>;
    ID: ResolverTypeWrapper<Scalars['ID']['output']>;
    IDestinationAnonymousSubject: ResolverTypeWrapper<IIDestinationAnonymousSubject>;
    IDocumentSelector: ResolverTypeWrapper<IIDocumentSelector>;
    IModel: ResolverTypeWrapper<IIModel>;
    IModelInput: IIModelInput;
    IObservableResult: ResolverTypeWrapper<IIObservableResult>;
    IResourceUtilizationSettings: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['IResourceUtilizationSettings']>;
    ISourceAnonymousSubject: ResolverTypeWrapper<IISourceAnonymousSubject>;
    ISwitchMapOperator: ResolverTypeWrapper<IISwitchMapOperator>;
    ITextDocumentIdentifier: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['ITextDocumentIdentifier']>;
    IViewComponentData: ResolverTypeWrapper<IIViewComponentData>;
    IViewComponentDataInput: IIViewComponentDataInput;
    IWorkspaceRoot: ResolverTypeWrapper<IIWorkspaceRoot>;
    IWorkspaceRootInput: IIWorkspaceRootInput;
    InstalledExtension: ResolverTypeWrapper<IInstalledExtension>;
    Int: ResolverTypeWrapper<Scalars['Int']['output']>;
    JSON: ResolverTypeWrapper<Scalars['JSON']['output']>;
    JSONObject: ResolverTypeWrapper<Scalars['JSONObject']['output']>;
    KeyBinding: ResolverTypeWrapper<IKeyBinding>;
    Localization: ResolverTypeWrapper<ILocalization>;
    LocalizationTranslation: ResolverTypeWrapper<ILocalizationTranslation>;
    Location: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['Location']>;
    MailTemplateId: IMailTemplateId;
    MarkupContent: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['MarkupContent']>;
    MarkupKind: IMarkupKind;
    MenuId: IMenuId;
    MenuItem: ResolverTypeWrapper<IMenuItem>;
    MenuItemAction: ResolverTypeWrapper<IMenuItemAction>;
    MenuItemActionContext: ResolverTypeWrapper<IMenuItemActionContext>;
    MenuItemActionDebug: ResolverTypeWrapper<IMenuItemActionDebug>;
    MenuItemActionEditor: ResolverTypeWrapper<IMenuItemActionEditor>;
    MenuItemActionEditorTitle: ResolverTypeWrapper<IMenuItemActionEditorTitle>;
    MenuItemActionScm: ResolverTypeWrapper<IMenuItemActionScm>;
    MenuItemActionScmChange: ResolverTypeWrapper<IMenuItemActionScmChange>;
    MenuItemActionView: ResolverTypeWrapper<IMenuItemActionView>;
    MenuItemInput: IMenuItemInput;
    Menus: ResolverTypeWrapper<IMenus>;
    MessageLink: ResolverTypeWrapper<IMessageLink>;
    MessageLinkInput: IMessageLinkInput;
    MoleculerCronServiceName: IMoleculerCronServiceName;
    MoleculerServiceName: IMoleculerServiceName;
    Mutation: ResolverTypeWrapper<{}>;
    Node: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['Node']>;
    Notification: ResolverTypeWrapper<INotification>;
    NotificationActions: ResolverTypeWrapper<INotificationActions>;
    NotificationActionsInput: INotificationActionsInput;
    NotificationChangeEvent: ResolverTypeWrapper<INotificationChangeEvent>;
    NotificationChangeType: INotificationChangeType;
    NotificationInput: INotificationInput;
    NotificationMessage: ResolverTypeWrapper<INotificationMessage>;
    NotificationMessageInput: INotificationMessageInput;
    NotificationSeverity: INotificationSeverity;
    NotificationViewItem: ResolverTypeWrapper<INotificationViewItem>;
    NotificationViewItemLabelKind: INotificationViewItemLabelKind;
    NotificationViewItemProgress: ResolverTypeWrapper<INotificationViewItemProgress>;
    NotificationViewItemProgressState: ResolverTypeWrapper<INotificationViewItemProgressState>;
    Notifications: ResolverTypeWrapper<INotifications>;
    Observable: ResolverTypeWrapper<Scalars['Observable']['output']>;
    OpenDocumentParamsInput: IOpenDocumentParamsInput;
    OpenDocumentTextParamsInput: IOpenDocumentTextParamsInput;
    PageInfo: ResolverTypeWrapper<IPageInfo>;
    Position: ResolverTypeWrapper<IPosition>;
    PositionInput: IPositionInput;
    ProcessMonitoring: ResolverTypeWrapper<IProcessMonitoring>;
    PromptChoiceInput: IPromptChoiceInput;
    PromptChoiceRun: IPromptChoiceRun;
    PromptOptionsCancel: IPromptOptionsCancel;
    PromptOptionsInput: IPromptOptionsInput;
    ProvideTextDocumentLocationSignature: ResolverTypeWrapper<IProvideTextDocumentLocationSignature>;
    ProvideTextDocumentLocationSignatureInput: IProvideTextDocumentLocationSignatureInput;
    Query: ResolverTypeWrapper<{}>;
    Range: ResolverTypeWrapper<IRange>;
    RangeInput: IRangeInput;
    RegistryEntry: ResolverTypeWrapper<IRegistryEntry>;
    RegistryExtension: ResolverTypeWrapper<IRegistryExtension>;
    RegistryExtensionConnection: ResolverTypeWrapper<IRegistryExtensionConnection>;
    RegistryPublisher: ResolverTypeWrapper<IRegistryPublisher>;
    RegistryPublisherConnection: ResolverTypeWrapper<IRegistryPublisherConnection>;
    Scripts: ResolverTypeWrapper<IScripts>;
    Snippet: ResolverTypeWrapper<ISnippet>;
    Sort: ISort;
    SortEnum: ISortEnum;
    String: ResolverTypeWrapper<Scalars['String']['output']>;
    Subscription: ResolverTypeWrapper<{}>;
    TextDocumentIdentifier: ResolverTypeWrapper<ITextDocumentIdentifier>;
    TextDocumentIdentifierInput: ITextDocumentIdentifierInput;
    TextDocumentItem: ResolverTypeWrapper<ITextDocumentItem>;
    TextDocumentItemInput: ITextDocumentItemInput;
    TextDocumentPositionParams: ResolverTypeWrapper<IResolversInterfaceTypes<IResolversTypes>['TextDocumentPositionParams']>;
    TextDocumentPositionParamsInput: ITextDocumentPositionParamsInput;
    TextDocumentRegistrationOptions: ResolverTypeWrapper<ITextDocumentRegistrationOptions>;
    TextDocumentRegistrationOptionsInput: ITextDocumentRegistrationOptionsInput;
    ThemeLabel: ResolverTypeWrapper<IThemeLabel>;
    Time: ResolverTypeWrapper<Scalars['Time']['output']>;
    Timestamp: ResolverTypeWrapper<Scalars['Timestamp']['output']>;
    URI: ResolverTypeWrapper<Scalars['URI']['output']>;
    URIInput: ResolverTypeWrapper<Scalars['URIInput']['output']>;
    ViewContainer: ResolverTypeWrapper<IViewContainer>;
};
/** Mapping between all available schema types and the resolvers parents */
export type IResolversParentTypes = {
    AdminIdeSettings: IAdminIdeSettings;
    Anchor: IAnchor;
    AnchorInput: IAnchorInput;
    AnyObject: Scalars['AnyObject']['output'];
    ArgsType: IArgsType;
    Assets: IAssets;
    Author: IAuthor;
    BaseExtension: IBaseExtension;
    Boolean: Scalars['Boolean']['output'];
    Bundles: IBundles;
    CommandHandlerDescriptionType: ICommandHandlerDescriptionType;
    CommandType: ICommandType;
    CommandsType: ICommandsType;
    ContextMenu: IContextMenu;
    ContextMenuInput: IContextMenuInput;
    Contributes: IContributes;
    ContributionAction: IContributionAction;
    ContributionActionInput: IContributionActionInput;
    ContributionActionItem: IContributionActionItem;
    ContributionActionRun: IContributionActionRun;
    ContributionActionRunInput: IContributionActionRunInput;
    ContributionActions: IContributionActions;
    ContributionView: IContributionView;
    Date: Scalars['Date']['output'];
    DateTime: Scalars['DateTime']['output'];
    Debugger: IDebugger;
    DocSitePage: IDocSitePage;
    DocumentFilter: IDocumentFilter;
    EmptyResponse: IEmptyResponse;
    Engines: IEngines;
    Environment: IEnvironment;
    EnvironmentPayload: IEnvironmentPayload;
    ExtensionColor: IExtensionColor;
    ExtensionColorTypes: IExtensionColorTypes;
    ExtensionConfiguration: IExtensionConfiguration;
    ExtensionConfigurationProperty: IExtensionConfigurationProperty;
    ExtensionContributions: IExtensionContributions;
    ExtensionIdentifier: IExtensionIdentifier;
    ExtensionInstance: IExtensionInstance;
    ExtensionJSONValidation: IExtensionJsonValidation;
    ExtensionLanguage: IExtensionLanguage;
    ExtensionManifest: IExtensionManifest;
    ExtensionManifestBugs: IExtensionManifestBugs;
    ExtensionManifestRepository: IExtensionManifestRepository;
    ExtensionPackageType: IExtensionPackageType;
    ExtensionRegistry: IExtensionRegistry;
    ExtensionRegistryCreateExtensionResult: IExtensionRegistryCreateExtensionResult;
    ExtensionRegistryPublishExtensionResult: IExtensionRegistryPublishExtensionResult;
    ExtensionRegistryUpdateExtensionResult: IExtensionRegistryUpdateExtensionResult;
    ExtensionRelease: IExtensionRelease;
    FieldError: IFieldError;
    Float: Scalars['Float']['output'];
    GalleryBanner: IGalleryBanner;
    GalleryExtension: IGalleryExtension;
    GalleryExtensionAsset: IGalleryExtensionAsset;
    GalleryExtensionAssets: IGalleryExtensionAssets;
    GalleryExtensionProperties: IGalleryExtensionProperties;
    GalleryExtensionResources: IGalleryExtensionResources;
    GalleryFilter: IGalleryFilter;
    GalleryPager: IGalleryPager;
    GalleryQueryInput: IGalleryQueryInput;
    GeoLocation: IGeoLocation;
    Grammar: IGrammar;
    Hover: IResolversInterfaceTypes<IResolversParentTypes>['Hover'];
    IActivationRequest: IIActivationRequest;
    IBehaviorSubject: IIBehaviorSubject;
    IBehaviorSubjectValue: IIBehaviorSubjectValue;
    ID: Scalars['ID']['output'];
    IDestinationAnonymousSubject: IIDestinationAnonymousSubject;
    IDocumentSelector: IIDocumentSelector;
    IModel: IIModel;
    IModelInput: IIModelInput;
    IObservableResult: IIObservableResult;
    IResourceUtilizationSettings: IResolversInterfaceTypes<IResolversParentTypes>['IResourceUtilizationSettings'];
    ISourceAnonymousSubject: IISourceAnonymousSubject;
    ISwitchMapOperator: IISwitchMapOperator;
    ITextDocumentIdentifier: IResolversInterfaceTypes<IResolversParentTypes>['ITextDocumentIdentifier'];
    IViewComponentData: IIViewComponentData;
    IViewComponentDataInput: IIViewComponentDataInput;
    IWorkspaceRoot: IIWorkspaceRoot;
    IWorkspaceRootInput: IIWorkspaceRootInput;
    InstalledExtension: IInstalledExtension;
    Int: Scalars['Int']['output'];
    JSON: Scalars['JSON']['output'];
    JSONObject: Scalars['JSONObject']['output'];
    KeyBinding: IKeyBinding;
    Localization: ILocalization;
    LocalizationTranslation: ILocalizationTranslation;
    Location: IResolversInterfaceTypes<IResolversParentTypes>['Location'];
    MarkupContent: IResolversInterfaceTypes<IResolversParentTypes>['MarkupContent'];
    MenuItem: IMenuItem;
    MenuItemAction: IMenuItemAction;
    MenuItemActionContext: IMenuItemActionContext;
    MenuItemActionDebug: IMenuItemActionDebug;
    MenuItemActionEditor: IMenuItemActionEditor;
    MenuItemActionEditorTitle: IMenuItemActionEditorTitle;
    MenuItemActionScm: IMenuItemActionScm;
    MenuItemActionScmChange: IMenuItemActionScmChange;
    MenuItemActionView: IMenuItemActionView;
    MenuItemInput: IMenuItemInput;
    Menus: IMenus;
    MessageLink: IMessageLink;
    MessageLinkInput: IMessageLinkInput;
    Mutation: {};
    Node: IResolversInterfaceTypes<IResolversParentTypes>['Node'];
    Notification: INotification;
    NotificationActions: INotificationActions;
    NotificationActionsInput: INotificationActionsInput;
    NotificationChangeEvent: INotificationChangeEvent;
    NotificationInput: INotificationInput;
    NotificationMessage: INotificationMessage;
    NotificationMessageInput: INotificationMessageInput;
    NotificationViewItem: INotificationViewItem;
    NotificationViewItemProgress: INotificationViewItemProgress;
    NotificationViewItemProgressState: INotificationViewItemProgressState;
    Notifications: INotifications;
    Observable: Scalars['Observable']['output'];
    OpenDocumentParamsInput: IOpenDocumentParamsInput;
    OpenDocumentTextParamsInput: IOpenDocumentTextParamsInput;
    PageInfo: IPageInfo;
    Position: IPosition;
    PositionInput: IPositionInput;
    ProcessMonitoring: IProcessMonitoring;
    PromptChoiceInput: IPromptChoiceInput;
    PromptChoiceRun: IPromptChoiceRun;
    PromptOptionsCancel: IPromptOptionsCancel;
    PromptOptionsInput: IPromptOptionsInput;
    ProvideTextDocumentLocationSignature: IProvideTextDocumentLocationSignature;
    ProvideTextDocumentLocationSignatureInput: IProvideTextDocumentLocationSignatureInput;
    Query: {};
    Range: IRange;
    RangeInput: IRangeInput;
    RegistryEntry: IRegistryEntry;
    RegistryExtension: IRegistryExtension;
    RegistryExtensionConnection: IRegistryExtensionConnection;
    RegistryPublisher: IRegistryPublisher;
    RegistryPublisherConnection: IRegistryPublisherConnection;
    Scripts: IScripts;
    Snippet: ISnippet;
    Sort: ISort;
    String: Scalars['String']['output'];
    Subscription: {};
    TextDocumentIdentifier: ITextDocumentIdentifier;
    TextDocumentIdentifierInput: ITextDocumentIdentifierInput;
    TextDocumentItem: ITextDocumentItem;
    TextDocumentItemInput: ITextDocumentItemInput;
    TextDocumentPositionParams: IResolversInterfaceTypes<IResolversParentTypes>['TextDocumentPositionParams'];
    TextDocumentPositionParamsInput: ITextDocumentPositionParamsInput;
    TextDocumentRegistrationOptions: ITextDocumentRegistrationOptions;
    TextDocumentRegistrationOptionsInput: ITextDocumentRegistrationOptionsInput;
    ThemeLabel: IThemeLabel;
    Time: Scalars['Time']['output'];
    Timestamp: Scalars['Timestamp']['output'];
    URI: Scalars['URI']['output'];
    URIInput: Scalars['URIInput']['output'];
    ViewContainer: IViewContainer;
};
export type IAdminIdeSettingsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['AdminIdeSettings'] = IResolversParentTypes['AdminIdeSettings']> = {
    dummy?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IAnchorResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Anchor'] = IResolversParentTypes['Anchor']> = {
    height?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    width?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    x?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    y?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export interface IAnyObjectScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['AnyObject'], any> {
    name: 'AnyObject';
}
export type IArgsTypeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ArgsType'] = IResolversParentTypes['ArgsType']> = {
    constraint?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    description?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    name?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IAssetsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Assets'] = IResolversParentTypes['Assets']> = {
    Content?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    Type?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IAuthorResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Author'] = IResolversParentTypes['Author']> = {
    name?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IBaseExtensionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['BaseExtension'] = IResolversParentTypes['BaseExtension']> = {
    galleryIdentifier?: Resolver<Maybe<IResolversTypes['ExtensionIdentifier']>, ParentType, ContextType>;
    identifier?: Resolver<Maybe<IResolversTypes['ExtensionIdentifier']>, ParentType, ContextType>;
    location?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
    manifest?: Resolver<Maybe<IResolversTypes['ExtensionManifest']>, ParentType, ContextType>;
    type?: Resolver<Maybe<IResolversTypes['ExtensionType']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IBundlesResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Bundles'] = IResolversParentTypes['Bundles']> = {
    browser?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    server?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ICommandHandlerDescriptionTypeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['CommandHandlerDescriptionType'] = IResolversParentTypes['CommandHandlerDescriptionType']> = {
    args?: Resolver<Maybe<Array<Maybe<IResolversTypes['ArgsType']>>>, ParentType, ContextType>;
    description?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    returns?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ICommandTypeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['CommandType'] = IResolversParentTypes['CommandType']> = {
    description?: Resolver<Maybe<IResolversTypes['CommandHandlerDescriptionType']>, ParentType, ContextType>;
    handler?: Resolver<Maybe<IResolversTypes['AnyObject']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ICommandsTypeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['CommandsType'] = IResolversParentTypes['CommandsType']> = {
    commands?: Resolver<Maybe<Array<Maybe<IResolversTypes['CommandType']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IContextMenuResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ContextMenu'] = IResolversParentTypes['ContextMenu']> = {
    anchor?: Resolver<Maybe<IResolversTypes['Anchor']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    isShow?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    menuItems?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItem']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IContributesResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Contributes'] = IResolversParentTypes['Contributes']> = {
    actions?: Resolver<Maybe<Array<Maybe<IResolversTypes['ContributionActions']>>>, ParentType, ContextType>;
    menus?: Resolver<Maybe<IResolversTypes['Menus']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IContributionActionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ContributionAction'] = IResolversParentTypes['ContributionAction']> = {
    checked?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    class?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    enabled?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    label?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    radio?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    run?: Resolver<Maybe<IResolversTypes['ContributionActionRun']>, ParentType, ContextType>;
    tooltip?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IContributionActionItemResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ContributionActionItem'] = IResolversParentTypes['ContributionActionItem']> = {
    description?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    label?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IContributionActionRunResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ContributionActionRun'] = IResolversParentTypes['ContributionActionRun']> = {
    document?: Resolver<Maybe<IResolversTypes['AnyObject']>, ParentType, ContextType>;
    type?: Resolver<Maybe<IResolversTypes['GraphqlCallType']>, ParentType, ContextType>;
    variables?: Resolver<Maybe<IResolversTypes['AnyObject']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IContributionActionsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ContributionActions'] = IResolversParentTypes['ContributionActions']> = {
    actionItem?: Resolver<Maybe<IResolversTypes['ContributionActionItem']>, ParentType, ContextType>;
    category?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    command?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    title?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IContributionViewResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ContributionView'] = IResolversParentTypes['ContributionView']> = {
    id?: Resolver<Maybe<IResolversTypes['ID']>, ParentType, ContextType>;
    name?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export interface IDateScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Date'], any> {
    name: 'Date';
}
export interface IDateTimeScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['DateTime'], any> {
    name: 'DateTime';
}
export type IDebuggerResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Debugger'] = IResolversParentTypes['Debugger']> = {
    label?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    runtime?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    type?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IDocSitePageResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['DocSitePage'] = IResolversParentTypes['DocSitePage']> = {
    contentHTML?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    filePath?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    indexHTML?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    title?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IDocumentFilterResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['DocumentFilter'] = IResolversParentTypes['DocumentFilter']> = {
    language?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    pattern?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    schema?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IEmptyResponseResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['EmptyResponse'] = IResolversParentTypes['EmptyResponse']> = {
    alwaysNil?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IEnginesResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Engines'] = IResolversParentTypes['Engines']> = {
    node?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    vscode?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IEnvironmentResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Environment'] = IResolversParentTypes['Environment']> = {
    extHostLogsPath?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
    extensionDevelopmentLocationURI?: Resolver<Maybe<Array<Maybe<IResolversTypes['URI']>>>, ParentType, ContextType>;
    extensionEnabledProposedApi?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    extensionTestsLocationURI?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
    isExtensionDevelopment?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    logExtensionHostCommunication?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    logsPath?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    remoteAuthority?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    sessionId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    sync?: Resolver<Maybe<IResolversTypes['EnvironmentSync']>, ParentType, ContextType>;
    userDataPath?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    userDataSyncHome?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
    userDataSyncLogResource?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
    webviewCspSource?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    webviewExternalEndpoint?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    webviewResourceRoot?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionColorResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionColor'] = IResolversParentTypes['ExtensionColor']> = {
    defaults?: Resolver<Maybe<IResolversTypes['ExtensionColorTypes']>, ParentType, ContextType>;
    description?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['ID']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionColorTypesResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionColorTypes'] = IResolversParentTypes['ExtensionColorTypes']> = {
    dark?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    highContrast?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    light?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionConfigurationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionConfiguration'] = IResolversParentTypes['ExtensionConfiguration']> = {
    properties?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionConfigurationPropertyResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionConfigurationProperty'] = IResolversParentTypes['ExtensionConfigurationProperty']> = {
    defaults?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    description?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    type?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionContributionsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionContributions'] = IResolversParentTypes['ExtensionContributions']> = {
    actions?: Resolver<Maybe<Array<Maybe<IResolversTypes['ContributionActions']>>>, ParentType, ContextType>;
    colors?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionColor']>>>, ParentType, ContextType>;
    commands?: Resolver<Maybe<Array<Maybe<IResolversTypes['ContributionActions']>>>, ParentType, ContextType>;
    configuration?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionConfiguration']>>>, ParentType, ContextType>;
    debuggers?: Resolver<Maybe<Array<Maybe<IResolversTypes['Debugger']>>>, ParentType, ContextType>;
    grammars?: Resolver<Maybe<Array<Maybe<IResolversTypes['Grammar']>>>, ParentType, ContextType>;
    iconThemes?: Resolver<Maybe<Array<Maybe<IResolversTypes['ThemeLabel']>>>, ParentType, ContextType>;
    jsonValidation?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionJSONValidation']>>>, ParentType, ContextType>;
    keybindings?: Resolver<Maybe<Array<Maybe<IResolversTypes['KeyBinding']>>>, ParentType, ContextType>;
    languages?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionLanguage']>>>, ParentType, ContextType>;
    localizations?: Resolver<Maybe<Array<Maybe<IResolversTypes['Localization']>>>, ParentType, ContextType>;
    menus?: Resolver<Maybe<IResolversTypes['Menus']>, ParentType, ContextType>;
    snippets?: Resolver<Maybe<Array<Maybe<IResolversTypes['Snippet']>>>, ParentType, ContextType>;
    themes?: Resolver<Maybe<Array<Maybe<IResolversTypes['ThemeLabel']>>>, ParentType, ContextType>;
    views?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    viewsContainers?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionIdentifierResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionIdentifier'] = IResolversParentTypes['ExtensionIdentifier']> = {
    id?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uuid?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionInstanceResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionInstance'] = IResolversParentTypes['ExtensionInstance']> = {
    env?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    extensionID?: Resolver<Maybe<IResolversTypes['ID']>, ParentType, ContextType>;
    monit?: Resolver<Maybe<IResolversTypes['ProcessMonitoring']>, ParentType, ContextType>;
    name?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    path?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    pid?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    status?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionJsonValidationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionJSONValidation'] = IResolversParentTypes['ExtensionJSONValidation']> = {
    fileMatch?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    url?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionLanguageResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionLanguage'] = IResolversParentTypes['ExtensionLanguage']> = {
    aliases?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    extensions?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['ID']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionManifestResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionManifest'] = IResolversParentTypes['ExtensionManifest']> = {
    activationEvents?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    api?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    assets?: Resolver<Maybe<Array<Maybe<IResolversTypes['Assets']>>>, ParentType, ContextType>;
    author?: Resolver<Maybe<IResolversTypes['Author']>, ParentType, ContextType>;
    badges?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    bugs?: Resolver<Maybe<IResolversTypes['ExtensionManifestBugs']>, ParentType, ContextType>;
    bundle?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    bundleURL?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    bundles?: Resolver<Maybe<IResolversTypes['Bundles']>, ParentType, ContextType>;
    categories?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    contributes?: Resolver<Maybe<IResolversTypes['ExtensionContributions']>, ParentType, ContextType>;
    dependencies?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    description?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    devDependencies?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    displayName?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    enableProposedApi?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    engines?: Resolver<Maybe<IResolversTypes['Engines']>, ParentType, ContextType>;
    extension?: Resolver<Maybe<IResolversTypes['ExtensionPackageType']>, ParentType, ContextType>;
    extensionDependencies?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    extensionID?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    extensionKind?: Resolver<Maybe<IResolversTypes['ExtensionKind']>, ParentType, ContextType>;
    extensionPack?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    galleryBanner?: Resolver<Maybe<IResolversTypes['GalleryBanner']>, ParentType, ContextType>;
    homepage?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    icon?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    keywords?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    license?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    main?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    makrdown?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    name?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    preview?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    publisher?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    qna?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    raw?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    readme?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    repository?: Resolver<Maybe<IResolversTypes['ExtensionManifestRepository']>, ParentType, ContextType>;
    scripts?: Resolver<Maybe<IResolversTypes['Scripts']>, ParentType, ContextType>;
    tags?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    url?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    version?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionManifestBugsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionManifestBugs'] = IResolversParentTypes['ExtensionManifestBugs']> = {
    email?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    url?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionManifestRepositoryResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionManifestRepository'] = IResolversParentTypes['ExtensionManifestRepository']> = {
    type?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    url?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionPackageTypeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionPackageType'] = IResolversParentTypes['ExtensionPackageType']> = {
    type?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionRegistryResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionRegistry'] = IResolversParentTypes['ExtensionRegistry']> = {
    extension?: Resolver<Maybe<IResolversTypes['RegistryExtension']>, ParentType, ContextType, RequireFields<IExtensionRegistryExtensionArgs, 'extensionID'>>;
    extensions?: Resolver<IResolversTypes['RegistryExtensionConnection'], ParentType, ContextType, RequireFields<IExtensionRegistryExtensionsArgs, 'includeWIP' | 'local' | 'remote'>>;
    localExtensionIDPrefix?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    publishers?: Resolver<IResolversTypes['RegistryPublisherConnection'], ParentType, ContextType, Partial<IExtensionRegistryPublishersArgs>>;
    releases?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionRelease']>>>, ParentType, ContextType, RequireFields<IExtensionRegistryReleasesArgs, 'extensionID'>>;
    viewerPublishers?: Resolver<Array<IResolversTypes['RegistryPublisher']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionRegistryCreateExtensionResultResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionRegistryCreateExtensionResult'] = IResolversParentTypes['ExtensionRegistryCreateExtensionResult']> = {
    extension?: Resolver<IResolversTypes['RegistryExtension'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionRegistryPublishExtensionResultResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionRegistryPublishExtensionResult'] = IResolversParentTypes['ExtensionRegistryPublishExtensionResult']> = {
    extension?: Resolver<IResolversTypes['RegistryExtension'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionRegistryUpdateExtensionResultResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionRegistryUpdateExtensionResult'] = IResolversParentTypes['ExtensionRegistryUpdateExtensionResult']> = {
    extension?: Resolver<IResolversTypes['RegistryExtension'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IExtensionReleaseResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ExtensionRelease'] = IResolversParentTypes['ExtensionRelease']> = {
    activationEvents?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    bundle?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    bundleURL?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    creatorUserId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    extensionID?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['ID']>, ParentType, ContextType>;
    manifest?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    releaseVersion?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    sourceMap?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    version?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IFieldErrorResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['FieldError'] = IResolversParentTypes['FieldError']> = {
    field?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    message?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGalleryBannerResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GalleryBanner'] = IResolversParentTypes['GalleryBanner']> = {
    color?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    theme?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGalleryExtensionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GalleryExtension'] = IResolversParentTypes['GalleryExtension']> = {
    assets?: Resolver<Maybe<IResolversTypes['GalleryExtensionAssets']>, ParentType, ContextType>;
    date?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    description?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    displayName?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    icon?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    identifier?: Resolver<Maybe<IResolversTypes['ExtensionIdentifier']>, ParentType, ContextType>;
    installCount?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    name?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    preview?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    properties?: Resolver<Maybe<IResolversTypes['GalleryExtensionProperties']>, ParentType, ContextType>;
    publisher?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    publisherDisplayName?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    publisherId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    rating?: Resolver<Maybe<IResolversTypes['Float']>, ParentType, ContextType>;
    ratingCount?: Resolver<Maybe<IResolversTypes['Float']>, ParentType, ContextType>;
    resources?: Resolver<Maybe<IResolversTypes['GalleryExtensionResources']>, ParentType, ContextType>;
    version?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGalleryExtensionAssetResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GalleryExtensionAsset'] = IResolversParentTypes['GalleryExtensionAsset']> = {
    fallbackUri?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uri?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGalleryExtensionAssetsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GalleryExtensionAssets'] = IResolversParentTypes['GalleryExtensionAssets']> = {
    changelog?: Resolver<Maybe<IResolversTypes['GalleryExtensionAsset']>, ParentType, ContextType>;
    coreTranslations?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    download?: Resolver<Maybe<IResolversTypes['GalleryExtensionAsset']>, ParentType, ContextType>;
    icon?: Resolver<Maybe<IResolversTypes['GalleryExtensionAsset']>, ParentType, ContextType>;
    license?: Resolver<Maybe<IResolversTypes['GalleryExtensionAsset']>, ParentType, ContextType>;
    manifest?: Resolver<Maybe<IResolversTypes['GalleryExtensionAsset']>, ParentType, ContextType>;
    readme?: Resolver<Maybe<IResolversTypes['GalleryExtensionAsset']>, ParentType, ContextType>;
    repository?: Resolver<Maybe<IResolversTypes['GalleryExtensionAsset']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGalleryExtensionPropertiesResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GalleryExtensionProperties'] = IResolversParentTypes['GalleryExtensionProperties']> = {
    dependencies?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    engine?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    extensionPack?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    localizedLanguages?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGalleryExtensionResourcesResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GalleryExtensionResources'] = IResolversParentTypes['GalleryExtensionResources']> = {
    changelog?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    download?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    icon?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    license?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    manifest?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    readme?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    repository?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGalleryPagerResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GalleryPager'] = IResolversParentTypes['GalleryPager']> = {
    firstPage?: Resolver<Maybe<Array<Maybe<IResolversTypes['GalleryExtension']>>>, ParentType, ContextType>;
    page?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    pageSize?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    total?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGeoLocationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['GeoLocation'] = IResolversParentTypes['GeoLocation']> = {
    coordinates?: Resolver<Maybe<Array<Maybe<IResolversTypes['Float']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IGrammarResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Grammar'] = IResolversParentTypes['Grammar']> = {
    language?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IHoverResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Hover'] = IResolversParentTypes['Hover']> = {
    __resolveType: TypeResolveFn<null, ParentType, ContextType>;
    contents?: Resolver<Maybe<IResolversTypes['MarkupContent']>, ParentType, ContextType>;
    range?: Resolver<Maybe<IResolversTypes['Range']>, ParentType, ContextType>;
};
export type IIBehaviorSubjectResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IBehaviorSubject'] = IResolversParentTypes['IBehaviorSubject']> = {
    _isScalar?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    closed?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    hasError?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    isStopped?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    observers?: Resolver<Maybe<Array<Maybe<IResolversTypes['JSON']>>>, ParentType, ContextType>;
    thrownError?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    value?: Resolver<Maybe<Array<Maybe<IResolversTypes['IBehaviorSubjectValue']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIBehaviorSubjectValueResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IBehaviorSubjectValue'] = IResolversParentTypes['IBehaviorSubjectValue']> = {
    provider?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    registrationOptions?: Resolver<Maybe<IResolversTypes['IDocumentSelector']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIDestinationAnonymousSubjectResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IDestinationAnonymousSubject'] = IResolversParentTypes['IDestinationAnonymousSubject']> = {
    _isScalar?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    closed?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    destination?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    hasError?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    isStopped?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    observers?: Resolver<Maybe<Array<Maybe<IResolversTypes['JSON']>>>, ParentType, ContextType>;
    operator?: Resolver<Maybe<IResolversTypes['ISwitchMapOperator']>, ParentType, ContextType>;
    source?: Resolver<Maybe<IResolversTypes['IBehaviorSubject']>, ParentType, ContextType>;
    thrownError?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIDocumentSelectorResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IDocumentSelector'] = IResolversParentTypes['IDocumentSelector']> = {
    documentSelector?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIModelResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IModel'] = IResolversParentTypes['IModel']> = {
    roots?: Resolver<Maybe<IResolversTypes['IWorkspaceRoot']>, ParentType, ContextType>;
    visibleViewComponents?: Resolver<Maybe<Array<Maybe<IResolversTypes['IViewComponentData']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIObservableResultResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IObservableResult'] = IResolversParentTypes['IObservableResult']> = {
    _isScalar?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    closed?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    destination?: Resolver<Maybe<IResolversTypes['IDestinationAnonymousSubject']>, ParentType, ContextType>;
    hasError?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    isStopped?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    observers?: Resolver<Maybe<Array<Maybe<IResolversTypes['JSON']>>>, ParentType, ContextType>;
    operator?: Resolver<Maybe<IResolversTypes['ISwitchMapOperator']>, ParentType, ContextType>;
    source?: Resolver<Maybe<IResolversTypes['ISourceAnonymousSubject']>, ParentType, ContextType>;
    thrownError?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIResourceUtilizationSettingsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IResourceUtilizationSettings'] = IResolversParentTypes['IResourceUtilizationSettings']> = {
    __resolveType: TypeResolveFn<null, ParentType, ContextType>;
    adminApiNamespace?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    subTopic?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
};
export type IISourceAnonymousSubjectResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ISourceAnonymousSubject'] = IResolversParentTypes['ISourceAnonymousSubject']> = {
    _isScalar?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    closed?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    destination?: Resolver<Maybe<IResolversTypes['IDestinationAnonymousSubject']>, ParentType, ContextType>;
    hasError?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    isStopped?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    observers?: Resolver<Maybe<Array<Maybe<IResolversTypes['JSON']>>>, ParentType, ContextType>;
    operator?: Resolver<Maybe<IResolversTypes['ISwitchMapOperator']>, ParentType, ContextType>;
    source?: Resolver<Maybe<IResolversTypes['IBehaviorSubject']>, ParentType, ContextType>;
    thrownError?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IISwitchMapOperatorResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ISwitchMapOperator'] = IResolversParentTypes['ISwitchMapOperator']> = {
    project?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IITextDocumentIdentifierResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ITextDocumentIdentifier'] = IResolversParentTypes['ITextDocumentIdentifier']> = {
    __resolveType: TypeResolveFn<'TextDocumentIdentifier' | 'TextDocumentItem', ParentType, ContextType>;
    languageId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uri?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
};
export type IIViewComponentDataResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IViewComponentData'] = IResolversParentTypes['IViewComponentData']> = {
    isActive?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    item?: Resolver<Maybe<IResolversTypes['TextDocumentItem']>, ParentType, ContextType>;
    type?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IIWorkspaceRootResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['IWorkspaceRoot'] = IResolversParentTypes['IWorkspaceRoot']> = {
    url?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IInstalledExtensionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['InstalledExtension'] = IResolversParentTypes['InstalledExtension']> = {
    extension?: Resolver<Maybe<IResolversTypes['GalleryExtension']>, ParentType, ContextType>;
    galleryIdentifier?: Resolver<Maybe<IResolversTypes['ExtensionIdentifier']>, ParentType, ContextType>;
    identifier?: Resolver<Maybe<IResolversTypes['ExtensionIdentifier']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export interface IJsonScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['JSON'], any> {
    name: 'JSON';
}
export interface IJsonObjectScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['JSONObject'], any> {
    name: 'JSONObject';
}
export type IKeyBindingResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['KeyBinding'] = IResolversParentTypes['KeyBinding']> = {
    command?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    key?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    linux?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    mac?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    when?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    win?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ILocalizationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Localization'] = IResolversParentTypes['Localization']> = {
    languageId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    languageName?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    localizedLanguageName?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    minimalTranslations?: Resolver<Maybe<IResolversTypes['JSON']>, ParentType, ContextType>;
    translations?: Resolver<Maybe<Array<Maybe<IResolversTypes['LocalizationTranslation']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ILocalizationTranslationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['LocalizationTranslation'] = IResolversParentTypes['LocalizationTranslation']> = {
    id?: Resolver<Maybe<IResolversTypes['ID']>, ParentType, ContextType>;
    path?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ILocationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Location'] = IResolversParentTypes['Location']> = {
    __resolveType: TypeResolveFn<'ProvideTextDocumentLocationSignature', ParentType, ContextType>;
    range?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    rangeOrUri?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    uri?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uriRangeOrPosition?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
};
export type IMarkupContentResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MarkupContent'] = IResolversParentTypes['MarkupContent']> = {
    __resolveType: TypeResolveFn<null, ParentType, ContextType>;
    kind?: Resolver<Maybe<IResolversTypes['MarkupKind']>, ParentType, ContextType>;
    value?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
};
export type IMenuItemResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItem'] = IResolversParentTypes['MenuItem']> = {
    enabled?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    id?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    label?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    run?: Resolver<Maybe<IResolversTypes['ContributionActionRun']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemAction'] = IResolversParentTypes['MenuItemAction']> = {
    action?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    when?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionContextResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemActionContext'] = IResolversParentTypes['MenuItemActionContext']> = {
    context?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionDebugResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemActionDebug'] = IResolversParentTypes['MenuItemActionDebug']> = {
    callstack?: Resolver<Maybe<IResolversTypes['MenuItemActionContext']>, ParentType, ContextType>;
    toolbar?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionEditorResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemActionEditor'] = IResolversParentTypes['MenuItemActionEditor']> = {
    context?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    title?: Resolver<Maybe<IResolversTypes['MenuItemActionEditorTitle']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionEditorTitleResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemActionEditorTitle'] = IResolversParentTypes['MenuItemActionEditorTitle']> = {
    context?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    own?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionScmResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemActionScm'] = IResolversParentTypes['MenuItemActionScm']> = {
    change?: Resolver<Maybe<IResolversTypes['MenuItemActionScmChange']>, ParentType, ContextType>;
    resource?: Resolver<Maybe<IResolversTypes['MenuItemActionContext']>, ParentType, ContextType>;
    resourceGroup?: Resolver<Maybe<IResolversTypes['MenuItemActionContext']>, ParentType, ContextType>;
    title?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionScmChangeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemActionScmChange'] = IResolversParentTypes['MenuItemActionScmChange']> = {
    title?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenuItemActionViewResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MenuItemActionView'] = IResolversParentTypes['MenuItemActionView']> = {
    item?: Resolver<Maybe<IResolversTypes['MenuItemActionContext']>, ParentType, ContextType>;
    title?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMenusResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Menus'] = IResolversParentTypes['Menus']> = {
    commandPalette?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    debug?: Resolver<Maybe<IResolversTypes['MenuItemActionDebug']>, ParentType, ContextType>;
    editor?: Resolver<Maybe<IResolversTypes['MenuItemActionEditor']>, ParentType, ContextType>;
    explorer?: Resolver<Maybe<IResolversTypes['MenuItemActionContext']>, ParentType, ContextType>;
    scm?: Resolver<Maybe<IResolversTypes['MenuItemActionScm']>, ParentType, ContextType>;
    touchBar?: Resolver<Maybe<Array<Maybe<IResolversTypes['MenuItemAction']>>>, ParentType, ContextType>;
    view?: Resolver<Maybe<IResolversTypes['MenuItemActionView']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMessageLinkResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['MessageLink'] = IResolversParentTypes['MessageLink']> = {
    href?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    length?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    name?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    offset?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IMutationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Mutation'] = IResolversParentTypes['Mutation']> = {
    activate?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, RequireFields<IMutationActivateArgs, 'request'>>;
    addNotification?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationAddNotificationArgs>>;
    closeNotification?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationCloseNotificationArgs>>;
    codeLenseProviderDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationCodeLenseProviderDefinitionArgs>>;
    completionProviderDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationCompletionProviderDefinitionArgs>>;
    copy?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationCopyArgs>>;
    createExtension?: Resolver<IResolversTypes['RegistryExtension'], ParentType, ContextType, RequireFields<IMutationCreateExtensionArgs, 'name' | 'publisher'>>;
    definitionDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationDefinitionDefinitionArgs>>;
    deleteExtension?: Resolver<IResolversTypes['EmptyResponse'], ParentType, ContextType, RequireFields<IMutationDeleteExtensionArgs, 'extension'>>;
    documentFormattingProviderDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationDocumentFormattingProviderDefinitionArgs>>;
    documentHighLightProviderDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationDocumentHighLightProviderDefinitionArgs>>;
    documentSymbolDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationDocumentSymbolDefinitionArgs>>;
    dummy?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    handler?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationHandlerArgs>>;
    hideContextMenu?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    hoverProviderDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationHoverProviderDefinitionArgs>>;
    install?: Resolver<Maybe<IResolversTypes['ExtensionIdentifier']>, ParentType, ContextType, RequireFields<IMutationInstallArgs, 'vsix'>>;
    notify?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationNotifyArgs>>;
    notifyError?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationNotifyErrorArgs>>;
    notifyInfo?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationNotifyInfoArgs>>;
    notifyPrompt?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationNotifyPromptArgs>>;
    notifyWarn?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationNotifyWarnArgs>>;
    openLanguageDocument?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationOpenLanguageDocumentArgs>>;
    publishExtension?: Resolver<IResolversTypes['ExtensionRegistryPublishExtensionResult'], ParentType, ContextType, RequireFields<IMutationPublishExtensionArgs, 'extensionID' | 'force' | 'manifest'>>;
    referenceProviderDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationReferenceProviderDefinitionArgs>>;
    removeExtension?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, RequireFields<IMutationRemoveExtensionArgs, 'id'>>;
    renameDefinition?: Resolver<Maybe<IResolversTypes['Observable']>, ParentType, ContextType, Partial<IMutationRenameDefinitionArgs>>;
    runMenuAction?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationRunMenuActionArgs>>;
    showContextMenu?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationShowContextMenuArgs>>;
    startExtensionHost?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationStartExtensionHostArgs>>;
    updateExtension?: Resolver<IResolversTypes['RegistryExtension'], ParentType, ContextType, RequireFields<IMutationUpdateExtensionArgs, 'extension'>>;
    updateModel?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IMutationUpdateModelArgs>>;
};
export type INodeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Node'] = IResolversParentTypes['Node']> = {
    __resolveType: TypeResolveFn<'RegistryExtension', ParentType, ContextType>;
    id?: Resolver<IResolversTypes['ID'], ParentType, ContextType>;
};
export type INotificationResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Notification'] = IResolversParentTypes['Notification']> = {
    actions?: Resolver<Maybe<IResolversTypes['NotificationActions']>, ParentType, ContextType>;
    index?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    message?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    severity?: Resolver<Maybe<IResolversTypes['NotificationSeverity']>, ParentType, ContextType>;
    source?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    sticky?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type INotificationActionsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['NotificationActions'] = IResolversParentTypes['NotificationActions']> = {
    primary?: Resolver<Maybe<Array<Maybe<IResolversTypes['ContributionAction']>>>, ParentType, ContextType>;
    secondary?: Resolver<Maybe<Array<Maybe<IResolversTypes['ContributionAction']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type INotificationChangeEventResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['NotificationChangeEvent'] = IResolversParentTypes['NotificationChangeEvent']> = {
    index?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    item?: Resolver<Maybe<IResolversTypes['NotificationViewItem']>, ParentType, ContextType>;
    kind?: Resolver<Maybe<IResolversTypes['NotificationChangeType']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type INotificationMessageResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['NotificationMessage'] = IResolversParentTypes['NotificationMessage']> = {
    links?: Resolver<Maybe<Array<Maybe<IResolversTypes['MessageLink']>>>, ParentType, ContextType>;
    original?: Resolver<Maybe<IResolversTypes['NotificationMessage']>, ParentType, ContextType>;
    raw?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    value?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type INotificationViewItemResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['NotificationViewItem'] = IResolversParentTypes['NotificationViewItem']> = {
    action?: Resolver<Maybe<IResolversTypes['NotificationActions']>, ParentType, ContextType>;
    canCollapse?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    expanded?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    message?: Resolver<Maybe<IResolversTypes['NotificationMessage']>, ParentType, ContextType>;
    progress?: Resolver<Maybe<IResolversTypes['NotificationViewItemProgress']>, ParentType, ContextType>;
    severity?: Resolver<Maybe<IResolversTypes['NotificationSeverity']>, ParentType, ContextType>;
    silent?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    source?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    sticky?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type INotificationViewItemProgressResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['NotificationViewItemProgress'] = IResolversParentTypes['NotificationViewItemProgress']> = {
    state?: Resolver<Maybe<IResolversTypes['NotificationViewItemProgressState']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type INotificationViewItemProgressStateResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['NotificationViewItemProgressState'] = IResolversParentTypes['NotificationViewItemProgressState']> = {
    done?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    infinite?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    total?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    worked?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type INotificationsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Notifications'] = IResolversParentTypes['Notifications']> = {
    notifications?: Resolver<Maybe<Array<Maybe<IResolversTypes['Notification']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export interface IObservableScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Observable'], any> {
    name: 'Observable';
}
export type IPageInfoResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['PageInfo'] = IResolversParentTypes['PageInfo']> = {
    hasNextPage?: Resolver<IResolversTypes['Boolean'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IPositionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Position'] = IResolversParentTypes['Position']> = {
    character?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    column?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    line?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    lineNumber?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IProcessMonitoringResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ProcessMonitoring'] = IResolversParentTypes['ProcessMonitoring']> = {
    cpu?: Resolver<Maybe<IResolversTypes['Float']>, ParentType, ContextType>;
    memory?: Resolver<Maybe<IResolversTypes['Float']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IProvideTextDocumentLocationSignatureResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ProvideTextDocumentLocationSignature'] = IResolversParentTypes['ProvideTextDocumentLocationSignature']> = {
    position?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    range?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    rangeOrUri?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    textDocument?: Resolver<Maybe<IResolversTypes['TextDocumentIdentifier']>, ParentType, ContextType>;
    uri?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uriRangeOrPosition?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IQueryResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Query'] = IResolversParentTypes['Query']> = {
    contextMenu?: Resolver<Maybe<IResolversTypes['ContextMenu']>, ParentType, ContextType>;
    docSitePage?: Resolver<Maybe<IResolversTypes['DocSitePage']>, ParentType, ContextType, RequireFields<IQueryDocSitePageArgs, 'path'>>;
    extension?: Resolver<Maybe<IResolversTypes['RegistryExtension']>, ParentType, ContextType, RequireFields<IQueryExtensionArgs, 'extensionID'>>;
    extensionRegistry?: Resolver<IResolversTypes['ExtensionRegistry'], ParentType, ContextType>;
    extensions?: Resolver<IResolversTypes['RegistryExtensionConnection'], ParentType, ContextType, RequireFields<IQueryExtensionsArgs, 'includeWIP' | 'local' | 'remote'>>;
    gallery?: Resolver<Maybe<IResolversTypes['GalleryPager']>, ParentType, ContextType, Partial<IQueryGalleryArgs>>;
    galleryExtension?: Resolver<Maybe<IResolversTypes['GalleryExtension']>, ParentType, ContextType, RequireFields<IQueryGalleryExtensionArgs, 'extensionID'>>;
    installed?: Resolver<Maybe<Array<Maybe<IResolversTypes['InstalledExtension']>>>, ParentType, ContextType>;
    instances?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionInstance']>>>, ParentType, ContextType>;
    node?: Resolver<Maybe<IResolversTypes['Node']>, ParentType, ContextType, RequireFields<IQueryNodeArgs, 'id'>>;
    notifications?: Resolver<Maybe<IResolversTypes['Notifications']>, ParentType, ContextType>;
    registerProvider?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IQueryRegisterProviderArgs>>;
    releases?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionRelease']>>>, ParentType, ContextType, RequireFields<IQueryReleasesArgs, 'extensionID'>>;
    showNotification?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType, Partial<IQueryShowNotificationArgs>>;
};
export type IRangeResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Range'] = IResolversParentTypes['Range']> = {
    end?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    endColumn?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    endLineNumber?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    start?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    startColumn?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    startLineNumber?: Resolver<Maybe<IResolversTypes['Int']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IRegistryEntryResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['RegistryEntry'] = IResolversParentTypes['RegistryEntry']> = {
    provider?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    registrationOptions?: Resolver<Maybe<IResolversTypes['TextDocumentRegistrationOptions']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IRegistryExtensionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['RegistryExtension'] = IResolversParentTypes['RegistryExtension']> = {
    activationEvents?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    extensionID?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    extensionIDWithoutRegistry?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    id?: Resolver<IResolversTypes['ID'], ParentType, ContextType>;
    isLocal?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    manifest?: Resolver<Maybe<IResolversTypes['ExtensionManifest']>, ParentType, ContextType>;
    name?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    publisher?: Resolver<Maybe<IResolversTypes['RegistryPublisher']>, ParentType, ContextType>;
    releases?: Resolver<Maybe<Array<Maybe<IResolversTypes['ExtensionRelease']>>>, ParentType, ContextType>;
    remoteURL?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    updatedAt?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    url?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uuid?: Resolver<IResolversTypes['String'], ParentType, ContextType>;
    version?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    viewerCanAdminister?: Resolver<Maybe<IResolversTypes['Boolean']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IRegistryExtensionConnectionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['RegistryExtensionConnection'] = IResolversParentTypes['RegistryExtensionConnection']> = {
    error?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    nodes?: Resolver<Array<IResolversTypes['RegistryExtension']>, ParentType, ContextType>;
    pageInfo?: Resolver<IResolversTypes['PageInfo'], ParentType, ContextType>;
    totalCount?: Resolver<IResolversTypes['Int'], ParentType, ContextType>;
    url?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IRegistryPublisherResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['RegistryPublisher'] = IResolversParentTypes['RegistryPublisher']> = {
    UserId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IRegistryPublisherConnectionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['RegistryPublisherConnection'] = IResolversParentTypes['RegistryPublisherConnection']> = {
    nodes?: Resolver<Array<IResolversTypes['RegistryPublisher']>, ParentType, ContextType>;
    pageInfo?: Resolver<IResolversTypes['PageInfo'], ParentType, ContextType>;
    totalCount?: Resolver<IResolversTypes['Int'], ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IScriptsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Scripts'] = IResolversParentTypes['Scripts']> = {
    cdebasebuild?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    cdebasepublish?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ISnippetResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Snippet'] = IResolversParentTypes['Snippet']> = {
    language?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ISubscriptionResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['Subscription'] = IResolversParentTypes['Subscription']> = {
    dummy?: SubscriptionResolver<Maybe<IResolversTypes['Int']>, "dummy", ParentType, ContextType>;
};
export type ITextDocumentIdentifierResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['TextDocumentIdentifier'] = IResolversParentTypes['TextDocumentIdentifier']> = {
    languageId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uri?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ITextDocumentItemResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['TextDocumentItem'] = IResolversParentTypes['TextDocumentItem']> = {
    languageId?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    text?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uri?: Resolver<Maybe<IResolversTypes['URI']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type ITextDocumentPositionParamsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['TextDocumentPositionParams'] = IResolversParentTypes['TextDocumentPositionParams']> = {
    __resolveType: TypeResolveFn<'ProvideTextDocumentLocationSignature', ParentType, ContextType>;
    position?: Resolver<Maybe<IResolversTypes['Position']>, ParentType, ContextType>;
    textDocument?: Resolver<Maybe<IResolversTypes['TextDocumentIdentifier']>, ParentType, ContextType>;
};
export type ITextDocumentRegistrationOptionsResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['TextDocumentRegistrationOptions'] = IResolversParentTypes['TextDocumentRegistrationOptions']> = {
    documentSelector?: Resolver<Maybe<Array<Maybe<IResolversTypes['String']>>>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IThemeLabelResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ThemeLabel'] = IResolversParentTypes['ThemeLabel']> = {
    label?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    path?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    uiTheme?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export interface ITimeScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Time'], any> {
    name: 'Time';
}
export interface ITimestampScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['Timestamp'], any> {
    name: 'Timestamp';
}
export interface IUriScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['URI'], any> {
    name: 'URI';
}
export interface IUriInputScalarConfig extends GraphQLScalarTypeConfig<IResolversTypes['URIInput'], any> {
    name: 'URIInput';
}
export type IViewContainerResolvers<ContextType = MyContext, ParentType extends IResolversParentTypes['ViewContainer'] = IResolversParentTypes['ViewContainer']> = {
    id?: Resolver<Maybe<IResolversTypes['ID']>, ParentType, ContextType>;
    title?: Resolver<Maybe<IResolversTypes['String']>, ParentType, ContextType>;
    __isTypeOf?: IsTypeOfResolverFn<ParentType, ContextType>;
};
export type IResolvers<ContextType = MyContext> = {
    AdminIdeSettings?: IAdminIdeSettingsResolvers<ContextType>;
    Anchor?: IAnchorResolvers<ContextType>;
    AnyObject?: GraphQLScalarType;
    ArgsType?: IArgsTypeResolvers<ContextType>;
    Assets?: IAssetsResolvers<ContextType>;
    Author?: IAuthorResolvers<ContextType>;
    BaseExtension?: IBaseExtensionResolvers<ContextType>;
    Bundles?: IBundlesResolvers<ContextType>;
    CommandHandlerDescriptionType?: ICommandHandlerDescriptionTypeResolvers<ContextType>;
    CommandType?: ICommandTypeResolvers<ContextType>;
    CommandsType?: ICommandsTypeResolvers<ContextType>;
    ContextMenu?: IContextMenuResolvers<ContextType>;
    Contributes?: IContributesResolvers<ContextType>;
    ContributionAction?: IContributionActionResolvers<ContextType>;
    ContributionActionItem?: IContributionActionItemResolvers<ContextType>;
    ContributionActionRun?: IContributionActionRunResolvers<ContextType>;
    ContributionActions?: IContributionActionsResolvers<ContextType>;
    ContributionView?: IContributionViewResolvers<ContextType>;
    Date?: GraphQLScalarType;
    DateTime?: GraphQLScalarType;
    Debugger?: IDebuggerResolvers<ContextType>;
    DocSitePage?: IDocSitePageResolvers<ContextType>;
    DocumentFilter?: IDocumentFilterResolvers<ContextType>;
    EmptyResponse?: IEmptyResponseResolvers<ContextType>;
    Engines?: IEnginesResolvers<ContextType>;
    Environment?: IEnvironmentResolvers<ContextType>;
    ExtensionColor?: IExtensionColorResolvers<ContextType>;
    ExtensionColorTypes?: IExtensionColorTypesResolvers<ContextType>;
    ExtensionConfiguration?: IExtensionConfigurationResolvers<ContextType>;
    ExtensionConfigurationProperty?: IExtensionConfigurationPropertyResolvers<ContextType>;
    ExtensionContributions?: IExtensionContributionsResolvers<ContextType>;
    ExtensionIdentifier?: IExtensionIdentifierResolvers<ContextType>;
    ExtensionInstance?: IExtensionInstanceResolvers<ContextType>;
    ExtensionJSONValidation?: IExtensionJsonValidationResolvers<ContextType>;
    ExtensionLanguage?: IExtensionLanguageResolvers<ContextType>;
    ExtensionManifest?: IExtensionManifestResolvers<ContextType>;
    ExtensionManifestBugs?: IExtensionManifestBugsResolvers<ContextType>;
    ExtensionManifestRepository?: IExtensionManifestRepositoryResolvers<ContextType>;
    ExtensionPackageType?: IExtensionPackageTypeResolvers<ContextType>;
    ExtensionRegistry?: IExtensionRegistryResolvers<ContextType>;
    ExtensionRegistryCreateExtensionResult?: IExtensionRegistryCreateExtensionResultResolvers<ContextType>;
    ExtensionRegistryPublishExtensionResult?: IExtensionRegistryPublishExtensionResultResolvers<ContextType>;
    ExtensionRegistryUpdateExtensionResult?: IExtensionRegistryUpdateExtensionResultResolvers<ContextType>;
    ExtensionRelease?: IExtensionReleaseResolvers<ContextType>;
    FieldError?: IFieldErrorResolvers<ContextType>;
    GalleryBanner?: IGalleryBannerResolvers<ContextType>;
    GalleryExtension?: IGalleryExtensionResolvers<ContextType>;
    GalleryExtensionAsset?: IGalleryExtensionAssetResolvers<ContextType>;
    GalleryExtensionAssets?: IGalleryExtensionAssetsResolvers<ContextType>;
    GalleryExtensionProperties?: IGalleryExtensionPropertiesResolvers<ContextType>;
    GalleryExtensionResources?: IGalleryExtensionResourcesResolvers<ContextType>;
    GalleryPager?: IGalleryPagerResolvers<ContextType>;
    GeoLocation?: IGeoLocationResolvers<ContextType>;
    Grammar?: IGrammarResolvers<ContextType>;
    Hover?: IHoverResolvers<ContextType>;
    IBehaviorSubject?: IIBehaviorSubjectResolvers<ContextType>;
    IBehaviorSubjectValue?: IIBehaviorSubjectValueResolvers<ContextType>;
    IDestinationAnonymousSubject?: IIDestinationAnonymousSubjectResolvers<ContextType>;
    IDocumentSelector?: IIDocumentSelectorResolvers<ContextType>;
    IModel?: IIModelResolvers<ContextType>;
    IObservableResult?: IIObservableResultResolvers<ContextType>;
    IResourceUtilizationSettings?: IIResourceUtilizationSettingsResolvers<ContextType>;
    ISourceAnonymousSubject?: IISourceAnonymousSubjectResolvers<ContextType>;
    ISwitchMapOperator?: IISwitchMapOperatorResolvers<ContextType>;
    ITextDocumentIdentifier?: IITextDocumentIdentifierResolvers<ContextType>;
    IViewComponentData?: IIViewComponentDataResolvers<ContextType>;
    IWorkspaceRoot?: IIWorkspaceRootResolvers<ContextType>;
    InstalledExtension?: IInstalledExtensionResolvers<ContextType>;
    JSON?: GraphQLScalarType;
    JSONObject?: GraphQLScalarType;
    KeyBinding?: IKeyBindingResolvers<ContextType>;
    Localization?: ILocalizationResolvers<ContextType>;
    LocalizationTranslation?: ILocalizationTranslationResolvers<ContextType>;
    Location?: ILocationResolvers<ContextType>;
    MarkupContent?: IMarkupContentResolvers<ContextType>;
    MenuItem?: IMenuItemResolvers<ContextType>;
    MenuItemAction?: IMenuItemActionResolvers<ContextType>;
    MenuItemActionContext?: IMenuItemActionContextResolvers<ContextType>;
    MenuItemActionDebug?: IMenuItemActionDebugResolvers<ContextType>;
    MenuItemActionEditor?: IMenuItemActionEditorResolvers<ContextType>;
    MenuItemActionEditorTitle?: IMenuItemActionEditorTitleResolvers<ContextType>;
    MenuItemActionScm?: IMenuItemActionScmResolvers<ContextType>;
    MenuItemActionScmChange?: IMenuItemActionScmChangeResolvers<ContextType>;
    MenuItemActionView?: IMenuItemActionViewResolvers<ContextType>;
    Menus?: IMenusResolvers<ContextType>;
    MessageLink?: IMessageLinkResolvers<ContextType>;
    Mutation?: IMutationResolvers<ContextType>;
    Node?: INodeResolvers<ContextType>;
    Notification?: INotificationResolvers<ContextType>;
    NotificationActions?: INotificationActionsResolvers<ContextType>;
    NotificationChangeEvent?: INotificationChangeEventResolvers<ContextType>;
    NotificationMessage?: INotificationMessageResolvers<ContextType>;
    NotificationViewItem?: INotificationViewItemResolvers<ContextType>;
    NotificationViewItemProgress?: INotificationViewItemProgressResolvers<ContextType>;
    NotificationViewItemProgressState?: INotificationViewItemProgressStateResolvers<ContextType>;
    Notifications?: INotificationsResolvers<ContextType>;
    Observable?: GraphQLScalarType;
    PageInfo?: IPageInfoResolvers<ContextType>;
    Position?: IPositionResolvers<ContextType>;
    ProcessMonitoring?: IProcessMonitoringResolvers<ContextType>;
    ProvideTextDocumentLocationSignature?: IProvideTextDocumentLocationSignatureResolvers<ContextType>;
    Query?: IQueryResolvers<ContextType>;
    Range?: IRangeResolvers<ContextType>;
    RegistryEntry?: IRegistryEntryResolvers<ContextType>;
    RegistryExtension?: IRegistryExtensionResolvers<ContextType>;
    RegistryExtensionConnection?: IRegistryExtensionConnectionResolvers<ContextType>;
    RegistryPublisher?: IRegistryPublisherResolvers<ContextType>;
    RegistryPublisherConnection?: IRegistryPublisherConnectionResolvers<ContextType>;
    Scripts?: IScriptsResolvers<ContextType>;
    Snippet?: ISnippetResolvers<ContextType>;
    Subscription?: ISubscriptionResolvers<ContextType>;
    TextDocumentIdentifier?: ITextDocumentIdentifierResolvers<ContextType>;
    TextDocumentItem?: ITextDocumentItemResolvers<ContextType>;
    TextDocumentPositionParams?: ITextDocumentPositionParamsResolvers<ContextType>;
    TextDocumentRegistrationOptions?: ITextDocumentRegistrationOptionsResolvers<ContextType>;
    ThemeLabel?: IThemeLabelResolvers<ContextType>;
    Time?: GraphQLScalarType;
    Timestamp?: GraphQLScalarType;
    URI?: GraphQLScalarType;
    URIInput?: GraphQLScalarType;
    ViewContainer?: IViewContainerResolvers<ContextType>;
};
